/*  C code generated by apiwrapper */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <ctype.h>
#include <errno.h>

#if defined(_WIN32)
# include <windows.h>
# define OPT_CALLCONV __stdcall
  static char winErr[] = "Windows error";
  typedef HINSTANCE soHandle_t;
#elif defined(CIA_HP7)
# define OPT_CALLCONV
# include <unistd.h>
# include <dl.h>
  typedef shl_t soHandle_t;
#else
# define OPT_CALLCONV
# include <unistd.h>
# include <dlfcn.h>
  typedef void *soHandle_t;
#endif

typedef int (OPT_CALLCONV *errorCallbackFort_t) (int *errCount, const char *msg, int msgLen);
#if defined(_WIN32)
typedef __int64 INT64;
#elif defined(__LP64__) || defined(__axu__) || defined(_FCGLU_LP64_)
typedef signed long int INT64;
#else
typedef signed long long int INT64;
#endif

#include "gamsglobals.h"

static soHandle_t hLibGlobal;  /* global shared library handle */
static int isLoaded = 0;
static int objectCount = 0;
static int screenIndicator = 1;
static int exceptionIndicator = 0;
static int exitIndicator = 0;
static errorCallbackFort_t errorCallbackFort = NULL;
static int APIErrorCount = 0;
static int trimflag  = 1;

typedef char string255[256];
typedef char stringf255[255];
typedef char cBuf512_t[512];
typedef int optBoolean_t;
typedef union foo { void *p; INT64 i; } u64_t;


static void convertF2PAS (const char* src, char *dest, int s_len, int p_len)
{
  int i;
  int len;

  len = s_len;
  if (trimflag)
    for (;;) {
      if (len==0) break;
      if (src[len-1] != ' ') break;
      --len;
    }
  if (p_len<len)
    len = p_len;
  for (i=0; i<len; ++i)
    dest[i+1] = src[i];
  dest[0] = len;
} /* convertF2PAS */


static void convertPAS2F (const char *src, char *dest, int s_len)
{
  int i, len;
  unsigned char s0;

  for (i = 0;  i < s_len;  i++)
    dest[i] = ' ';
  s0 = src[0];
  len = s_len;
  if (s0 < len)
    len = s0;
  for (i = 0;  i < len;  i++)
    dest[i] = src[i+1];
} /* convertPAS2F */


static void convertF2C(const char* sf, char *sc, int fSize, int cSize)
{
  int i;
  int count;

  count = fSize;
  while ((count>0) && (sf[count-1]==' '))
    --count;
  if (cSize-1<count)
    count = cSize-1;
  for (i=0; i<count; ++i)
    sc[i] = sf[i];
  sc[count] = '\0';
} /* convertF2C */


static void convertC2F(const char* sc, char *sf, int s_len)
{
  int i, len;
  unsigned char s0;
  for (i=0; i<s_len; ++i)
    sf[i] = ' ';
  s0 = strlen(sc);
  len = s_len;
  if (s0 < len)
    len = s0;
  for (i=0; i<len; ++i)
    sf[i] = sc[i];
} /* convertC2F */

/* pad the buffer with blanks, including whacking the terminating nul */
static void blankPad (char *buf, int len, int siz)
{
  int i;

  if (siz >= len) {
    memset (buf+len, ' ', siz-len);
  }
}

typedef optBoolean_t (OPT_CALLCONV *XCreate_t) (void *popt);
static XCreate_t XCreate = NULL;
typedef optBoolean_t (OPT_CALLCONV *XFree_t)   (void *popt);
static XFree_t   XFree = NULL;
typedef int (OPT_CALLCONV *XAPIVersion_t) (int api, char *msg, int *cl);
static XAPIVersion_t XAPIVersion = NULL;
typedef int (OPT_CALLCONV *XCheck_t) (char *ep, int nargs, int s[], char *msg);
static XCheck_t XCheck = NULL;

static void errorHandling (const char *msg)
{
  int msgLen;
  int tmp;

  APIErrorCount++;
  if (screenIndicator) {
    printf("FIX ME in C glu: %s\n", msg);
    exit (1);
  }
  if (errorCallbackFort) {
    msgLen = strlen(msg);
    tmp = APIErrorCount;
    if (errorCallbackFort(&tmp, msg, msgLen))
      exit(1);
  }
  assert(!exceptionIndicator);
  if (exitIndicator)
    exit(1);
}



typedef void (OPT_CALLCONV *optSetLoadPath_t) (const char *s);
static optSetLoadPath_t optSetLoadPath = NULL;
typedef void (OPT_CALLCONV *optGetLoadPath_t) (char *s);
static optGetLoadPath_t optGetLoadPath = NULL;
int  OPT_CALLCONV d_optReadDefinition (void *popt, const char *fn)
{
  errorHandling("optReadDefinition could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optReadParameterFile (void *popt, const char *fn)
{
  errorHandling("optReadParameterFile could not be loaded or has wrong signature!");
  return 0;
}

void  OPT_CALLCONV d_optReadFromStr (void *popt, const char *s)
{
  errorHandling("optReadFromStr could not be loaded or has wrong signature!");
}

int  OPT_CALLCONV d_optWriteParameterFile (void *popt, const char *fn)
{
  errorHandling("optWriteParameterFile could not be loaded or has wrong signature!");
  return 0;
}

void  OPT_CALLCONV d_optClearMessages (void *popt)
{
  errorHandling("optClearMessages could not be loaded or has wrong signature!");
}

void  OPT_CALLCONV d_optAddMessage (void *popt, const char *info)
{
  errorHandling("optAddMessage could not be loaded or has wrong signature!");
}

void  OPT_CALLCONV d_optGetMessage (void *popt, int N, char *info, int *iType)
{
  errorHandling("optGetMessage could not be loaded or has wrong signature!");
}

void  OPT_CALLCONV d_optResetAll (void *popt)
{
  errorHandling("optResetAll could not be loaded or has wrong signature!");
}

void  OPT_CALLCONV d_optResetAllRecent (void *popt)
{
  errorHandling("optResetAllRecent could not be loaded or has wrong signature!");
}

void  OPT_CALLCONV d_optResetRecentChanges (void *popt)
{
  errorHandling("optResetRecentChanges could not be loaded or has wrong signature!");
}

void  OPT_CALLCONV d_optShowHelp (void *popt, const char *HlpID)
{
  errorHandling("optShowHelp could not be loaded or has wrong signature!");
}

int  OPT_CALLCONV d_optResetNr (void *popt, int ANr)
{
  errorHandling("optResetNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optFindStr (void *popt, const char *AName, int *ANr, int *ARefNr)
{
  errorHandling("optFindStr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetInfoNr (void *popt, int ANr, int *ADefined, int *ADefinedR, int *ARefNr, int *ADataType, int *AOptType, int *ASubType)
{
  errorHandling("optGetInfoNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetValuesNr (void *popt, int ANr, char *ASName, int *AIVal, double *ADVal, char *ASVal)
{
  errorHandling("optGetValuesNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSetValuesNr (void *popt, int ANr, int AIVal, double ADVal, const char *ASVal)
{
  errorHandling("optSetValuesNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSetValues2Nr (void *popt, int ANr, int AIVal, double ADVal, const char *ASVal)
{
  errorHandling("optSetValues2Nr could not be loaded or has wrong signature!");
  return 0;
}

void  OPT_CALLCONV d_optVersion (void *popt, char *sversion)
{
  errorHandling("optVersion could not be loaded or has wrong signature!");
}

void  OPT_CALLCONV d_optDefinitionFile (void *popt, char *sfilename)
{
  errorHandling("optDefinitionFile could not be loaded or has wrong signature!");
}

int  OPT_CALLCONV d_optGetFromAnyStrList (void *popt, int idash, char *skey, char *sval)
{
  errorHandling("optGetFromAnyStrList could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetFromListStr (void *popt, const char *skey, char *sval)
{
  errorHandling("optGetFromListStr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optListCountStr (void *popt, const char *skey)
{
  errorHandling("optListCountStr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optReadFromListStr (void *popt, const char *skey, int iPos, char *sval)
{
  errorHandling("optReadFromListStr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSynonymCount (void *popt)
{
  errorHandling("optSynonymCount could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetSynonym (void *popt, int N, char *SSyn, char *SName)
{
  errorHandling("optGetSynonym could not be loaded or has wrong signature!");
  return 0;
}

void  OPT_CALLCONV d_optEchoSet (void *popt, int V)
{
  errorHandling("optEchoSet could not be loaded or has wrong signature!");
}

int  OPT_CALLCONV d_optEOLOnlySet (void *popt, int ival)
{
  errorHandling("optEOLOnlySet could not be loaded or has wrong signature!");
  return 0;
}

void  OPT_CALLCONV d_optNoBoundsSet (void *popt, int ival)
{
  errorHandling("optNoBoundsSet could not be loaded or has wrong signature!");
}

void  OPT_CALLCONV d_optErrorCount (void *popt, int *iErrors, int *iWarnings)
{
  errorHandling("optErrorCount could not be loaded or has wrong signature!");
}

int  OPT_CALLCONV d_optGetBoundsInt (void *popt, int ANr, int *ilval, int *ihval, int *idval)
{
  errorHandling("optGetBoundsInt could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetBoundsDbl (void *popt, int ANr, double *dlval, double *dhval, double *ddval)
{
  errorHandling("optGetBoundsDbl could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetDefaultStr (void *popt, int ANr, char *sval)
{
  errorHandling("optGetDefaultStr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetIntNr (void *popt, int ANr, int *AIVal)
{
  errorHandling("optGetIntNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetInt2Nr (void *popt, int ANr, int *AIVal)
{
  errorHandling("optGetInt2Nr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSetIntNr (void *popt, int ANr, int AIVal)
{
  errorHandling("optSetIntNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSetInt2Nr (void *popt, int ANr, int AIVal)
{
  errorHandling("optSetInt2Nr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetStrNr (void *popt, int ANr, char *ASVal)
{
  errorHandling("optGetStrNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetOptHelpNr (void *popt, int ANr, char *AName, int *AHc, int *AGroup)
{
  errorHandling("optGetOptHelpNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetEnumHelp (void *popt, int ANr, int AOrd, int *AHc, char *AHelpStr)
{
  errorHandling("optGetEnumHelp could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetEnumStrNr (void *popt, int ANr, char *ASVal, int *AOrd)
{
  errorHandling("optGetEnumStrNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetEnumCount (void *popt, int ANr, int *ACount)
{
  errorHandling("optGetEnumCount could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetEnumValue (void *popt, int ANr, int AOrd, int *AValInt, char *AValStr)
{
  errorHandling("optGetEnumValue could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetStr2Nr (void *popt, int ANr, char *ASVal)
{
  errorHandling("optGetStr2Nr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSetStrNr (void *popt, int ANr, const char *ASVal)
{
  errorHandling("optSetStrNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSetStr2Nr (void *popt, int ANr, const char *ASVal)
{
  errorHandling("optSetStr2Nr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetDblNr (void *popt, int ANr, double *ADVal)
{
  errorHandling("optGetDblNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetDbl2Nr (void *popt, int ANr, double *ADVal)
{
  errorHandling("optGetDbl2Nr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSetDblNr (void *popt, int ANr, double ADVal)
{
  errorHandling("optSetDblNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSetDbl2Nr (void *popt, int ANr, double ADVal)
{
  errorHandling("optSetDbl2Nr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetValStr (void *popt, const char *AName, char *ASVal)
{
  errorHandling("optGetValStr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetVal2Str (void *popt, const char *AName, char *ASVal)
{
  errorHandling("optGetVal2Str could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetNameNr (void *popt, int ANr, char *ASName)
{
  errorHandling("optGetNameNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetDefinedNr (void *popt, int ANr, int *AIVal)
{
  errorHandling("optGetDefinedNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetHelpNr (void *popt, int ANr, char *ASOpt, char *ASHelp)
{
  errorHandling("optGetHelpNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetGroupNr (void *popt, int ANr, char *AName, int *AGroup, int *AHc, char *AHelp)
{
  errorHandling("optGetGroupNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetGroupGrpNr (void *popt, int AGroup)
{
  errorHandling("optGetGroupGrpNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetOptGroupNr (void *popt, int ANr)
{
  errorHandling("optGetOptGroupNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetDotOptNr (void *popt, int ANr, char *AName, int *AObjNr, int *ADim, double *AValue)
{
  errorHandling("optGetDotOptNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetDotOptUel (void *popt, int ANr, int ADim, char *AUEL)
{
  errorHandling("optGetDotOptUel could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetIndicatorNr (void *popt, int ANr, char *EquName, char *VarName, int *EquDim, int *VarDim, int *AValue)
{
  errorHandling("optGetIndicatorNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetEquIndicatorNr (void *popt, int ANr, int ADim, char *AIndex)
{
  errorHandling("optGetEquIndicatorNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetVarIndicatorNr (void *popt, int ANr, int ADim, char *AIndex)
{
  errorHandling("optGetVarIndicatorNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optIndicatorCount (void *popt, int *ANrErrors)
{
  errorHandling("optIndicatorCount could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optDotOptCount (void *popt, int *ANrErrors)
{
  errorHandling("optDotOptCount could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSetRefNr (void *popt, int ANr, int AValue)
{
  errorHandling("optSetRefNr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optSetRefNrStr (void *popt, const char *AOpt, int AValue)
{
  errorHandling("optSetRefNrStr could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetConstName (void *popt, int cgroup, int cindex, char *cname)
{
  errorHandling("optGetConstName could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGetTypeName (void *popt, int TNr, char *sTName)
{
  errorHandling("optGetTypeName could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optLookUp (void *popt, const char *AOpt)
{
  errorHandling("optLookUp could not be loaded or has wrong signature!");
  return 0;
}

void  OPT_CALLCONV d_optReadFromPChar (void *popt, char *p)
{
  errorHandling("optReadFromPChar could not be loaded or has wrong signature!");
}

int  OPT_CALLCONV d_optCount (void *popt)
{
  errorHandling("optCount could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optMessageCount (void *popt)
{
  errorHandling("optMessageCount could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optGroupCount (void *popt)
{
  errorHandling("optGroupCount could not be loaded or has wrong signature!");
  return 0;
}

int  OPT_CALLCONV d_optRecentEnabled (void *popt)
{
  errorHandling("optRecentEnabled could not be loaded or has wrong signature!");
  return 0;
}

void OPT_CALLCONV d_optRecentEnabledSet (void *popt, int x)
{
  errorHandling("optRecentEnabledSet could not be loaded or has wrong signature!");
}


/* return dirName on success, NULL on failure */
static char *
extractFileDir (const char *fileName, char *dirName, int dirNameLen)
{
  int i, fileNameLen;
  const char *end, *s;
  char *t;

  if (NULL == fileName || NULL == dirName) {
    return NULL;
  }
  fileNameLen = (int) strlen(fileName);

#if defined(_WIN32)
  /* get the last delimiter */
  for (end = fileName + fileNameLen - 1;
       end >= fileName && '\\' != *end && ':' != *end;  end--);
  /* shave off the trailing delimiter if it isn't the first char,
   * it is a backslack, and it is not preceded by a delimiter
   */
  if (end > fileName && '\\' == *end
   && (! ('\\' == *(end-1) || ':' == *(end-1)))
     )
    end--;
#else
  /* non-Windows: implicitly, this is the Unix version */
  /* get the last delimiter */
  for (end = fileName + fileNameLen - 1;
       end >= fileName && '/' != *end;  end--);

  if (end > fileName && '/' == *end)
    end--;
#endif  /* if defined(_WIN32) */

  for (s = fileName, t = dirName;  s <= end;  s++, t++)
    *t = *s;
  *t = '\0';

  return dirName;
} /* extractFileDir */



typedef int (OPT_CALLCONV *optReadDefinition_t) (void *popt, const char *fn);
static optReadDefinition_t optReadDefinition = NULL;
typedef int (OPT_CALLCONV *optReadParameterFile_t) (void *popt, const char *fn);
static optReadParameterFile_t optReadParameterFile = NULL;
typedef void (OPT_CALLCONV *optReadFromStr_t) (void *popt, const char *s);
static optReadFromStr_t optReadFromStr = NULL;
typedef int (OPT_CALLCONV *optWriteParameterFile_t) (void *popt, const char *fn);
static optWriteParameterFile_t optWriteParameterFile = NULL;
typedef void (OPT_CALLCONV *optClearMessages_t) (void *popt);
static optClearMessages_t optClearMessages = NULL;
typedef void (OPT_CALLCONV *optAddMessage_t) (void *popt, const char *info);
static optAddMessage_t optAddMessage = NULL;
typedef void (OPT_CALLCONV *optGetMessage_t) (void *popt, int N, char *info, int *iType);
static optGetMessage_t optGetMessage = NULL;
typedef void (OPT_CALLCONV *optResetAll_t) (void *popt);
static optResetAll_t optResetAll = NULL;
typedef void (OPT_CALLCONV *optResetAllRecent_t) (void *popt);
static optResetAllRecent_t optResetAllRecent = NULL;
typedef void (OPT_CALLCONV *optResetRecentChanges_t) (void *popt);
static optResetRecentChanges_t optResetRecentChanges = NULL;
typedef void (OPT_CALLCONV *optShowHelp_t) (void *popt, const char *HlpID);
static optShowHelp_t optShowHelp = NULL;
typedef int (OPT_CALLCONV *optResetNr_t) (void *popt, int ANr);
static optResetNr_t optResetNr = NULL;
typedef int (OPT_CALLCONV *optFindStr_t) (void *popt, const char *AName, int *ANr, int *ARefNr);
static optFindStr_t optFindStr = NULL;
typedef int (OPT_CALLCONV *optGetInfoNr_t) (void *popt, int ANr, int *ADefined, int *ADefinedR, int *ARefNr, int *ADataType, int *AOptType, int *ASubType);
static optGetInfoNr_t optGetInfoNr = NULL;
typedef int (OPT_CALLCONV *optGetValuesNr_t) (void *popt, int ANr, char *ASName, int *AIVal, double *ADVal, char *ASVal);
static optGetValuesNr_t optGetValuesNr = NULL;
typedef int (OPT_CALLCONV *optSetValuesNr_t) (void *popt, int ANr, int AIVal, double ADVal, const char *ASVal);
static optSetValuesNr_t optSetValuesNr = NULL;
typedef int (OPT_CALLCONV *optSetValues2Nr_t) (void *popt, int ANr, int AIVal, double ADVal, const char *ASVal);
static optSetValues2Nr_t optSetValues2Nr = NULL;
typedef void (OPT_CALLCONV *optVersion_t) (void *popt, char *sversion);
static optVersion_t optVersion = NULL;
typedef void (OPT_CALLCONV *optDefinitionFile_t) (void *popt, char *sfilename);
static optDefinitionFile_t optDefinitionFile = NULL;
typedef int (OPT_CALLCONV *optGetFromAnyStrList_t) (void *popt, int idash, char *skey, char *sval);
static optGetFromAnyStrList_t optGetFromAnyStrList = NULL;
typedef int (OPT_CALLCONV *optGetFromListStr_t) (void *popt, const char *skey, char *sval);
static optGetFromListStr_t optGetFromListStr = NULL;
typedef int (OPT_CALLCONV *optListCountStr_t) (void *popt, const char *skey);
static optListCountStr_t optListCountStr = NULL;
typedef int (OPT_CALLCONV *optReadFromListStr_t) (void *popt, const char *skey, int iPos, char *sval);
static optReadFromListStr_t optReadFromListStr = NULL;
typedef int (OPT_CALLCONV *optSynonymCount_t) (void *popt);
static optSynonymCount_t optSynonymCount = NULL;
typedef int (OPT_CALLCONV *optGetSynonym_t) (void *popt, int N, char *SSyn, char *SName);
static optGetSynonym_t optGetSynonym = NULL;
typedef void (OPT_CALLCONV *optEchoSet_t) (void *popt, int V);
static optEchoSet_t optEchoSet = NULL;
typedef int (OPT_CALLCONV *optEOLOnlySet_t) (void *popt, int ival);
static optEOLOnlySet_t optEOLOnlySet = NULL;
typedef void (OPT_CALLCONV *optNoBoundsSet_t) (void *popt, int ival);
static optNoBoundsSet_t optNoBoundsSet = NULL;
typedef void (OPT_CALLCONV *optErrorCount_t) (void *popt, int *iErrors, int *iWarnings);
static optErrorCount_t optErrorCount = NULL;
typedef int (OPT_CALLCONV *optGetBoundsInt_t) (void *popt, int ANr, int *ilval, int *ihval, int *idval);
static optGetBoundsInt_t optGetBoundsInt = NULL;
typedef int (OPT_CALLCONV *optGetBoundsDbl_t) (void *popt, int ANr, double *dlval, double *dhval, double *ddval);
static optGetBoundsDbl_t optGetBoundsDbl = NULL;
typedef int (OPT_CALLCONV *optGetDefaultStr_t) (void *popt, int ANr, char *sval);
static optGetDefaultStr_t optGetDefaultStr = NULL;
typedef int (OPT_CALLCONV *optGetIntNr_t) (void *popt, int ANr, int *AIVal);
static optGetIntNr_t optGetIntNr = NULL;
typedef int (OPT_CALLCONV *optGetInt2Nr_t) (void *popt, int ANr, int *AIVal);
static optGetInt2Nr_t optGetInt2Nr = NULL;
typedef int (OPT_CALLCONV *optSetIntNr_t) (void *popt, int ANr, int AIVal);
static optSetIntNr_t optSetIntNr = NULL;
typedef int (OPT_CALLCONV *optSetInt2Nr_t) (void *popt, int ANr, int AIVal);
static optSetInt2Nr_t optSetInt2Nr = NULL;
typedef int (OPT_CALLCONV *optGetStrNr_t) (void *popt, int ANr, char *ASVal);
static optGetStrNr_t optGetStrNr = NULL;
typedef int (OPT_CALLCONV *optGetOptHelpNr_t) (void *popt, int ANr, char *AName, int *AHc, int *AGroup);
static optGetOptHelpNr_t optGetOptHelpNr = NULL;
typedef int (OPT_CALLCONV *optGetEnumHelp_t) (void *popt, int ANr, int AOrd, int *AHc, char *AHelpStr);
static optGetEnumHelp_t optGetEnumHelp = NULL;
typedef int (OPT_CALLCONV *optGetEnumStrNr_t) (void *popt, int ANr, char *ASVal, int *AOrd);
static optGetEnumStrNr_t optGetEnumStrNr = NULL;
typedef int (OPT_CALLCONV *optGetEnumCount_t) (void *popt, int ANr, int *ACount);
static optGetEnumCount_t optGetEnumCount = NULL;
typedef int (OPT_CALLCONV *optGetEnumValue_t) (void *popt, int ANr, int AOrd, int *AValInt, char *AValStr);
static optGetEnumValue_t optGetEnumValue = NULL;
typedef int (OPT_CALLCONV *optGetStr2Nr_t) (void *popt, int ANr, char *ASVal);
static optGetStr2Nr_t optGetStr2Nr = NULL;
typedef int (OPT_CALLCONV *optSetStrNr_t) (void *popt, int ANr, const char *ASVal);
static optSetStrNr_t optSetStrNr = NULL;
typedef int (OPT_CALLCONV *optSetStr2Nr_t) (void *popt, int ANr, const char *ASVal);
static optSetStr2Nr_t optSetStr2Nr = NULL;
typedef int (OPT_CALLCONV *optGetDblNr_t) (void *popt, int ANr, double *ADVal);
static optGetDblNr_t optGetDblNr = NULL;
typedef int (OPT_CALLCONV *optGetDbl2Nr_t) (void *popt, int ANr, double *ADVal);
static optGetDbl2Nr_t optGetDbl2Nr = NULL;
typedef int (OPT_CALLCONV *optSetDblNr_t) (void *popt, int ANr, double ADVal);
static optSetDblNr_t optSetDblNr = NULL;
typedef int (OPT_CALLCONV *optSetDbl2Nr_t) (void *popt, int ANr, double ADVal);
static optSetDbl2Nr_t optSetDbl2Nr = NULL;
typedef int (OPT_CALLCONV *optGetValStr_t) (void *popt, const char *AName, char *ASVal);
static optGetValStr_t optGetValStr = NULL;
typedef int (OPT_CALLCONV *optGetVal2Str_t) (void *popt, const char *AName, char *ASVal);
static optGetVal2Str_t optGetVal2Str = NULL;
typedef int (OPT_CALLCONV *optGetNameNr_t) (void *popt, int ANr, char *ASName);
static optGetNameNr_t optGetNameNr = NULL;
typedef int (OPT_CALLCONV *optGetDefinedNr_t) (void *popt, int ANr, int *AIVal);
static optGetDefinedNr_t optGetDefinedNr = NULL;
typedef int (OPT_CALLCONV *optGetHelpNr_t) (void *popt, int ANr, char *ASOpt, char *ASHelp);
static optGetHelpNr_t optGetHelpNr = NULL;
typedef int (OPT_CALLCONV *optGetGroupNr_t) (void *popt, int ANr, char *AName, int *AGroup, int *AHc, char *AHelp);
static optGetGroupNr_t optGetGroupNr = NULL;
typedef int (OPT_CALLCONV *optGetGroupGrpNr_t) (void *popt, int AGroup);
static optGetGroupGrpNr_t optGetGroupGrpNr = NULL;
typedef int (OPT_CALLCONV *optGetOptGroupNr_t) (void *popt, int ANr);
static optGetOptGroupNr_t optGetOptGroupNr = NULL;
typedef int (OPT_CALLCONV *optGetDotOptNr_t) (void *popt, int ANr, char *AName, int *AObjNr, int *ADim, double *AValue);
static optGetDotOptNr_t optGetDotOptNr = NULL;
typedef int (OPT_CALLCONV *optGetDotOptUel_t) (void *popt, int ANr, int ADim, char *AUEL);
static optGetDotOptUel_t optGetDotOptUel = NULL;
typedef int (OPT_CALLCONV *optGetIndicatorNr_t) (void *popt, int ANr, char *EquName, char *VarName, int *EquDim, int *VarDim, int *AValue);
static optGetIndicatorNr_t optGetIndicatorNr = NULL;
typedef int (OPT_CALLCONV *optGetEquIndicatorNr_t) (void *popt, int ANr, int ADim, char *AIndex);
static optGetEquIndicatorNr_t optGetEquIndicatorNr = NULL;
typedef int (OPT_CALLCONV *optGetVarIndicatorNr_t) (void *popt, int ANr, int ADim, char *AIndex);
static optGetVarIndicatorNr_t optGetVarIndicatorNr = NULL;
typedef int (OPT_CALLCONV *optIndicatorCount_t) (void *popt, int *ANrErrors);
static optIndicatorCount_t optIndicatorCount = NULL;
typedef int (OPT_CALLCONV *optDotOptCount_t) (void *popt, int *ANrErrors);
static optDotOptCount_t optDotOptCount = NULL;
typedef int (OPT_CALLCONV *optSetRefNr_t) (void *popt, int ANr, int AValue);
static optSetRefNr_t optSetRefNr = NULL;
typedef int (OPT_CALLCONV *optSetRefNrStr_t) (void *popt, const char *AOpt, int AValue);
static optSetRefNrStr_t optSetRefNrStr = NULL;
typedef int (OPT_CALLCONV *optGetConstName_t) (void *popt, int cgroup, int cindex, char *cname);
static optGetConstName_t optGetConstName = NULL;
typedef int (OPT_CALLCONV *optGetTypeName_t) (void *popt, int TNr, char *sTName);
static optGetTypeName_t optGetTypeName = NULL;
typedef int (OPT_CALLCONV *optLookUp_t) (void *popt, const char *AOpt);
static optLookUp_t optLookUp = NULL;
typedef void (OPT_CALLCONV *optReadFromPChar_t) (void *popt, char *p);
static optReadFromPChar_t optReadFromPChar = NULL;
typedef int (OPT_CALLCONV *optCount_t) (void *popt);
optCount_t optCount=NULL;
typedef int (OPT_CALLCONV *optMessageCount_t) (void *popt);
optMessageCount_t optMessageCount=NULL;
typedef int (OPT_CALLCONV *optGroupCount_t) (void *popt);
optGroupCount_t optGroupCount=NULL;
typedef int (OPT_CALLCONV *optRecentEnabled_t) (void *popt);
optRecentEnabled_t optRecentEnabled=NULL;
typedef void (OPT_CALLCONV *optRecentEnabledSet_t) (void *popt, int x);
static optRecentEnabledSet_t optRecentEnabledSet=NULL;

static soHandle_t
loadLib (const char *libName, char **errMsg)
{
  soHandle_t h;
  int flag = 0;

#if defined(_WIN32)
  h = LoadLibrary (libName);
  if (NULL == h) {
    *errMsg = winErr;
  }
  else {
    *errMsg = NULL;
  }
#elif defined(CIA_HP7)
  flag = BIND_IMMEDIATE | BIND_VERBOSE | DYNAMIC_PATH;
  h = shl_load (libName, flag, 0L);
  if (NULL == h) {
    *errMsg = strerror(errno);
  }
  else {
    *errMsg = NULL;
  }
#else
  (void) dlerror();
  h = dlopen (libName, RTLD_NOW);
  if (NULL == h) {
    *errMsg = dlerror();
  }
  else {
    *errMsg = NULL;
  }
#endif

  return h;
} /* loadLib */

static int
unLoadLib (soHandle_t h)
{
  int rc;

#if defined(_WIN32)
  rc = FreeLibrary (h);
  return ! rc;
#elif defined(CIA_HP7)
  rc = shl_unload (h);
#else
  rc = dlclose (h);
#endif
  return rc;
} /* unLoadLib */

static void *
loadSym (soHandle_t h, const char *sym, char **errMsg)
{
  void *s;
  const char *from;
  char *to;
  const char *tripSym;
  char lcbuf[257];
  char ucbuf[257];
  char ocbuf[257];
  size_t symLen;
  int trip;
#if defined(CIA_HP7)
  int rc;
#endif

  /* search in this order:
   *  1. original
   *  2. lower_
   *  3. upper_
   *  4. original_
   *  5. lower
   *  6. upper
   */

  symLen = 0;
  for (trip = 1;  trip <= 6;  trip++) {
    switch (trip) {
    case 1:                             /* original */
      tripSym = sym;
      break;
    case 2:                             /* lower_ */
      for (from = sym, to = lcbuf;  *from;  from++, to++) {
        *to = tolower(*from);
      }
      symLen = from - sym;
      *to++ = '_';
      *to = '\0';
      tripSym = lcbuf;
      break;
    case 3:                             /* upper_ */
      for (from = sym, to = ucbuf;  *from;  from++, to++) {
        *to = toupper(*from);
      }
      *to++ = '_';
      *to = '\0';
      tripSym = ucbuf;
      break;
    case 4:                             /* original_ */
      memcpy (ocbuf, sym, symLen);
      ocbuf[symLen] = '_';
      ocbuf[symLen+1] = '\0';
      tripSym = ocbuf;
      break;
    case 5:                             /* lower */
      lcbuf[symLen] = '\0';
      tripSym = lcbuf;
      break;
    case 6:                             /* upper */
      ucbuf[symLen] = '\0';
      tripSym = ucbuf;
      break;
    default:
      tripSym = sym;
    } /* end switch */
#if defined(_WIN32)
    s = GetProcAddress (h, tripSym);
    if (NULL != s) {
      return s;
    }
#elif defined(CIA_HP7)
    rc = shl_findsym (&h, tripSym, TYPE_UNDEFINED, &s);
    if (rc) {                     /* failure */
      *errMsg = strerror(errno);
    }
    else {                        /* success */
      *errMsg = NULL;
      return s;
    }
#else
    (void) dlerror();
    s = dlsym (h, tripSym);
    *errMsg = dlerror();
    if (NULL == *errMsg) {
      return s;
    }
#endif
  } /* end loop over symbol name variations */

  return NULL;
} /* loadSym */

/* TNAME = type name, ENAME = exported name */
#define LOADIT(TNAME,ENAME) symName = ENAME; TNAME = (TNAME##_t) loadSym (hLibGlobal, symName, &errMsg); if (NULL == TNAME) goto symMissing
#define LOADIT_ERR_OK(TNAME,ENAME) symName = ENAME; TNAME = (TNAME##_t) loadSym (hLibGlobal, symName, &errMsg)

#if defined(CIA_LEX) || defined(CIA_WEX) || defined(CIA_SOX)
# define SUFFIX "64"
#else
# define SUFFIX ""
#endif
#if defined(_WIN32)
# define BASENAME "optdclib"
# define EXTENSION ".dll"
#elif defined(CIA_HP7)
# define BASENAME "liboptdclib"
# define EXTENSION ".sl"
#elif defined(CIA_DAR) || defined(CIA_DII)
# define BASENAME "liboptdclib"
# define EXTENSION ".dylib"
#else
# define BASENAME "liboptdclib"
# define EXTENSION ".so"
#endif

/* XLibraryLoad: return 0 on success, ~0 on failure */
static int
XLibraryLoad (const char *dllName, char *errBuf, int errBufLen)
{
  char *errMsg;
  char *symName;
  int rc, elen, cl;
  char *ebuf;
  char dllNameBuf[512];

  if (isLoaded)
    return 0;
  if (NULL != dllName && '\0' != *dllName) {
    strncpy(dllNameBuf, dllName, sizeof(dllNameBuf));
    dllNameBuf[sizeof(dllNameBuf)-1] = '\0';
  }
  else {
    strcpy(dllNameBuf, BASENAME SUFFIX EXTENSION);
  }
  hLibGlobal = loadLib (dllNameBuf, &errMsg);
  if (NULL == hLibGlobal) {
    if (NULL != errBuf) {
      elen = errBufLen;  ebuf = errBuf;
      rc = sprintf (ebuf, "%.*s", elen, "Could not load shared library ");
      elen -= rc;  ebuf+= rc;
      rc = sprintf (ebuf, "%.*s", elen, dllNameBuf);
      elen -= rc;  ebuf+= rc;
      rc = sprintf (ebuf, "%.*s", elen, ": ");
      elen -= rc;  ebuf+= rc;
      rc = sprintf (ebuf, "%.*s", elen, errMsg);
      elen -= rc;  ebuf+= rc;
      errBuf[errBufLen-1] = '\0';
    }
    return 1;
  }
  else {
     /* printf ("Loaded shared library %s successfully\n", dllName); */
  }

  LOADIT(XCreate, "XCreate");
  LOADIT(XFree, "XFree");
  LOADIT(XCheck, "CXCheck");
  LOADIT(XAPIVersion, "CXAPIVersion");

  if (!XAPIVersion(2,errBuf,&cl))
    return 1;

  LOADIT_ERR_OK(optSetLoadPath, "CoptSetLoadPath");
  LOADIT_ERR_OK(optGetLoadPath, "CoptGetLoadPath");

  { int s[]={3,11};
    if(!XCheck("optReadDefinition",1,s,errBuf))  optReadDefinition=&d_optReadDefinition;
    else { LOADIT(optReadDefinition,"optReadDefinition"); }  }
  { int s[]={3,11};
    if(!XCheck("optReadParameterFile",1,s,errBuf))  optReadParameterFile=&d_optReadParameterFile;
    else { LOADIT(optReadParameterFile,"optReadParameterFile"); }  }
  { int s[]={0,11};
    if(!XCheck("optReadFromStr",1,s,errBuf))  optReadFromStr=&d_optReadFromStr;
    else { LOADIT(optReadFromStr,"optReadFromStr"); }  }
  { int s[]={3,11};
    if(!XCheck("optWriteParameterFile",1,s,errBuf))  optWriteParameterFile=&d_optWriteParameterFile;
    else { LOADIT(optWriteParameterFile,"optWriteParameterFile"); }  }
  { int s[]={0};
    if(!XCheck("optClearMessages",0,s,errBuf))  optClearMessages=&d_optClearMessages;
    else { LOADIT(optClearMessages,"optClearMessages"); }  }
  { int s[]={0,11};
    if(!XCheck("optAddMessage",1,s,errBuf))  optAddMessage=&d_optAddMessage;
    else { LOADIT(optAddMessage,"optAddMessage"); }  }
  { int s[]={0,3,12,4};
    if(!XCheck("optGetMessage",3,s,errBuf))  optGetMessage=&d_optGetMessage;
    else { LOADIT(optGetMessage,"optGetMessage"); }  }
  { int s[]={0};
    if(!XCheck("optResetAll",0,s,errBuf))  optResetAll=&d_optResetAll;
    else { LOADIT(optResetAll,"optResetAll"); }  }
  { int s[]={0};
    if(!XCheck("optResetAllRecent",0,s,errBuf))  optResetAllRecent=&d_optResetAllRecent;
    else { LOADIT(optResetAllRecent,"optResetAllRecent"); }  }
  { int s[]={0};
    if(!XCheck("optResetRecentChanges",0,s,errBuf))  optResetRecentChanges=&d_optResetRecentChanges;
    else { LOADIT(optResetRecentChanges,"optResetRecentChanges"); }  }
  { int s[]={0,11};
    if(!XCheck("optShowHelp",1,s,errBuf))  optShowHelp=&d_optShowHelp;
    else { LOADIT(optShowHelp,"optShowHelp"); }  }
  { int s[]={3,3};
    if(!XCheck("optResetNr",1,s,errBuf))  optResetNr=&d_optResetNr;
    else { LOADIT(optResetNr,"optResetNr"); }  }
  { int s[]={3,11,4,4};
    if(!XCheck("optFindStr",3,s,errBuf))  optFindStr=&d_optFindStr;
    else { LOADIT(optFindStr,"optFindStr"); }  }
  { int s[]={3,3,4,4,4,4,4,4};
    if(!XCheck("optGetInfoNr",7,s,errBuf))  optGetInfoNr=&d_optGetInfoNr;
    else { LOADIT(optGetInfoNr,"optGetInfoNr"); }  }
  { int s[]={3,3,12,4,14,12};
    if(!XCheck("optGetValuesNr",5,s,errBuf))  optGetValuesNr=&d_optGetValuesNr;
    else { LOADIT(optGetValuesNr,"optGetValuesNr"); }  }
  { int s[]={3,3,3,13,11};
    if(!XCheck("optSetValuesNr",4,s,errBuf))  optSetValuesNr=&d_optSetValuesNr;
    else { LOADIT(optSetValuesNr,"optSetValuesNr"); }  }
  { int s[]={3,3,3,13,11};
    if(!XCheck("optSetValues2Nr",4,s,errBuf))  optSetValues2Nr=&d_optSetValues2Nr;
    else { LOADIT(optSetValues2Nr,"optSetValues2Nr"); }  }
  { int s[]={0,12};
    if(!XCheck("optVersion",1,s,errBuf))  optVersion=&d_optVersion;
    else { LOADIT(optVersion,"optVersion"); }  }
  { int s[]={0,12};
    if(!XCheck("optDefinitionFile",1,s,errBuf))  optDefinitionFile=&d_optDefinitionFile;
    else { LOADIT(optDefinitionFile,"optDefinitionFile"); }  }
  { int s[]={3,3,12,12};
    if(!XCheck("optGetFromAnyStrList",3,s,errBuf))  optGetFromAnyStrList=&d_optGetFromAnyStrList;
    else { LOADIT(optGetFromAnyStrList,"optGetFromAnyStrList"); }  }
  { int s[]={3,11,12};
    if(!XCheck("optGetFromListStr",2,s,errBuf))  optGetFromListStr=&d_optGetFromListStr;
    else { LOADIT(optGetFromListStr,"optGetFromListStr"); }  }
  { int s[]={3,11};
    if(!XCheck("optListCountStr",1,s,errBuf))  optListCountStr=&d_optListCountStr;
    else { LOADIT(optListCountStr,"optListCountStr"); }  }
  { int s[]={3,11,3,12};
    if(!XCheck("optReadFromListStr",3,s,errBuf))  optReadFromListStr=&d_optReadFromListStr;
    else { LOADIT(optReadFromListStr,"optReadFromListStr"); }  }
  { int s[]={3};
    if(!XCheck("optSynonymCount",0,s,errBuf))  optSynonymCount=&d_optSynonymCount;
    else { LOADIT(optSynonymCount,"optSynonymCount"); }  }
  { int s[]={3,3,12,12};
    if(!XCheck("optGetSynonym",3,s,errBuf))  optGetSynonym=&d_optGetSynonym;
    else { LOADIT(optGetSynonym,"optGetSynonym"); }  }
  { int s[]={0,3};
    if(!XCheck("optEchoSet",1,s,errBuf))  optEchoSet=&d_optEchoSet;
    else { LOADIT(optEchoSet,"optEchoSet"); }  }
  { int s[]={3,3};
    if(!XCheck("optEOLOnlySet",1,s,errBuf))  optEOLOnlySet=&d_optEOLOnlySet;
    else { LOADIT(optEOLOnlySet,"optEOLOnlySet"); }  }
  { int s[]={0,3};
    if(!XCheck("optNoBoundsSet",1,s,errBuf))  optNoBoundsSet=&d_optNoBoundsSet;
    else { LOADIT(optNoBoundsSet,"optNoBoundsSet"); }  }
  { int s[]={0,4,4};
    if(!XCheck("optErrorCount",2,s,errBuf))  optErrorCount=&d_optErrorCount;
    else { LOADIT(optErrorCount,"optErrorCount"); }  }
  { int s[]={3,3,4,4,4};
    if(!XCheck("optGetBoundsInt",4,s,errBuf))  optGetBoundsInt=&d_optGetBoundsInt;
    else { LOADIT(optGetBoundsInt,"optGetBoundsInt"); }  }
  { int s[]={3,3,14,14,14};
    if(!XCheck("optGetBoundsDbl",4,s,errBuf))  optGetBoundsDbl=&d_optGetBoundsDbl;
    else { LOADIT(optGetBoundsDbl,"optGetBoundsDbl"); }  }
  { int s[]={3,3,12};
    if(!XCheck("optGetDefaultStr",2,s,errBuf))  optGetDefaultStr=&d_optGetDefaultStr;
    else { LOADIT(optGetDefaultStr,"optGetDefaultStr"); }  }
  { int s[]={3,3,4};
    if(!XCheck("optGetIntNr",2,s,errBuf))  optGetIntNr=&d_optGetIntNr;
    else { LOADIT(optGetIntNr,"optGetIntNr"); }  }
  { int s[]={3,3,4};
    if(!XCheck("optGetInt2Nr",2,s,errBuf))  optGetInt2Nr=&d_optGetInt2Nr;
    else { LOADIT(optGetInt2Nr,"optGetInt2Nr"); }  }
  { int s[]={3,3,3};
    if(!XCheck("optSetIntNr",2,s,errBuf))  optSetIntNr=&d_optSetIntNr;
    else { LOADIT(optSetIntNr,"optSetIntNr"); }  }
  { int s[]={3,3,3};
    if(!XCheck("optSetInt2Nr",2,s,errBuf))  optSetInt2Nr=&d_optSetInt2Nr;
    else { LOADIT(optSetInt2Nr,"optSetInt2Nr"); }  }
  { int s[]={3,3,12};
    if(!XCheck("optGetStrNr",2,s,errBuf))  optGetStrNr=&d_optGetStrNr;
    else { LOADIT(optGetStrNr,"optGetStrNr"); }  }
  { int s[]={3,3,12,4,4};
    if(!XCheck("optGetOptHelpNr",4,s,errBuf))  optGetOptHelpNr=&d_optGetOptHelpNr;
    else { LOADIT(optGetOptHelpNr,"optGetOptHelpNr"); }  }
  { int s[]={3,3,3,4,12};
    if(!XCheck("optGetEnumHelp",4,s,errBuf))  optGetEnumHelp=&d_optGetEnumHelp;
    else { LOADIT(optGetEnumHelp,"optGetEnumHelp"); }  }
  { int s[]={3,3,12,4};
    if(!XCheck("optGetEnumStrNr",3,s,errBuf))  optGetEnumStrNr=&d_optGetEnumStrNr;
    else { LOADIT(optGetEnumStrNr,"optGetEnumStrNr"); }  }
  { int s[]={3,3,4};
    if(!XCheck("optGetEnumCount",2,s,errBuf))  optGetEnumCount=&d_optGetEnumCount;
    else { LOADIT(optGetEnumCount,"optGetEnumCount"); }  }
  { int s[]={3,3,3,4,12};
    if(!XCheck("optGetEnumValue",4,s,errBuf))  optGetEnumValue=&d_optGetEnumValue;
    else { LOADIT(optGetEnumValue,"optGetEnumValue"); }  }
  { int s[]={3,3,12};
    if(!XCheck("optGetStr2Nr",2,s,errBuf))  optGetStr2Nr=&d_optGetStr2Nr;
    else { LOADIT(optGetStr2Nr,"optGetStr2Nr"); }  }
  { int s[]={3,3,11};
    if(!XCheck("optSetStrNr",2,s,errBuf))  optSetStrNr=&d_optSetStrNr;
    else { LOADIT(optSetStrNr,"optSetStrNr"); }  }
  { int s[]={3,3,11};
    if(!XCheck("optSetStr2Nr",2,s,errBuf))  optSetStr2Nr=&d_optSetStr2Nr;
    else { LOADIT(optSetStr2Nr,"optSetStr2Nr"); }  }
  { int s[]={3,3,14};
    if(!XCheck("optGetDblNr",2,s,errBuf))  optGetDblNr=&d_optGetDblNr;
    else { LOADIT(optGetDblNr,"optGetDblNr"); }  }
  { int s[]={3,3,14};
    if(!XCheck("optGetDbl2Nr",2,s,errBuf))  optGetDbl2Nr=&d_optGetDbl2Nr;
    else { LOADIT(optGetDbl2Nr,"optGetDbl2Nr"); }  }
  { int s[]={3,3,13};
    if(!XCheck("optSetDblNr",2,s,errBuf))  optSetDblNr=&d_optSetDblNr;
    else { LOADIT(optSetDblNr,"optSetDblNr"); }  }
  { int s[]={3,3,13};
    if(!XCheck("optSetDbl2Nr",2,s,errBuf))  optSetDbl2Nr=&d_optSetDbl2Nr;
    else { LOADIT(optSetDbl2Nr,"optSetDbl2Nr"); }  }
  { int s[]={3,11,12};
    if(!XCheck("optGetValStr",2,s,errBuf))  optGetValStr=&d_optGetValStr;
    else { LOADIT(optGetValStr,"optGetValStr"); }  }
  { int s[]={3,11,12};
    if(!XCheck("optGetVal2Str",2,s,errBuf))  optGetVal2Str=&d_optGetVal2Str;
    else { LOADIT(optGetVal2Str,"optGetVal2Str"); }  }
  { int s[]={3,3,12};
    if(!XCheck("optGetNameNr",2,s,errBuf))  optGetNameNr=&d_optGetNameNr;
    else { LOADIT(optGetNameNr,"optGetNameNr"); }  }
  { int s[]={3,3,4};
    if(!XCheck("optGetDefinedNr",2,s,errBuf))  optGetDefinedNr=&d_optGetDefinedNr;
    else { LOADIT(optGetDefinedNr,"optGetDefinedNr"); }  }
  { int s[]={3,3,12,12};
    if(!XCheck("optGetHelpNr",3,s,errBuf))  optGetHelpNr=&d_optGetHelpNr;
    else { LOADIT(optGetHelpNr,"optGetHelpNr"); }  }
  { int s[]={3,3,12,4,4,12};
    if(!XCheck("optGetGroupNr",5,s,errBuf))  optGetGroupNr=&d_optGetGroupNr;
    else { LOADIT(optGetGroupNr,"optGetGroupNr"); }  }
  { int s[]={3,3};
    if(!XCheck("optGetGroupGrpNr",1,s,errBuf))  optGetGroupGrpNr=&d_optGetGroupGrpNr;
    else { LOADIT(optGetGroupGrpNr,"optGetGroupGrpNr"); }  }
  { int s[]={3,3};
    if(!XCheck("optGetOptGroupNr",1,s,errBuf))  optGetOptGroupNr=&d_optGetOptGroupNr;
    else { LOADIT(optGetOptGroupNr,"optGetOptGroupNr"); }  }
  { int s[]={3,3,12,4,4,14};
    if(!XCheck("optGetDotOptNr",5,s,errBuf))  optGetDotOptNr=&d_optGetDotOptNr;
    else { LOADIT(optGetDotOptNr,"optGetDotOptNr"); }  }
  { int s[]={3,3,3,12};
    if(!XCheck("optGetDotOptUel",3,s,errBuf))  optGetDotOptUel=&d_optGetDotOptUel;
    else { LOADIT(optGetDotOptUel,"optGetDotOptUel"); }  }
  { int s[]={3,3,12,12,4,4,4};
    if(!XCheck("optGetIndicatorNr",6,s,errBuf))  optGetIndicatorNr=&d_optGetIndicatorNr;
    else { LOADIT(optGetIndicatorNr,"optGetIndicatorNr"); }  }
  { int s[]={3,3,3,12};
    if(!XCheck("optGetEquIndicatorNr",3,s,errBuf))  optGetEquIndicatorNr=&d_optGetEquIndicatorNr;
    else { LOADIT(optGetEquIndicatorNr,"optGetEquIndicatorNr"); }  }
  { int s[]={3,3,3,12};
    if(!XCheck("optGetVarIndicatorNr",3,s,errBuf))  optGetVarIndicatorNr=&d_optGetVarIndicatorNr;
    else { LOADIT(optGetVarIndicatorNr,"optGetVarIndicatorNr"); }  }
  { int s[]={3,4};
    if(!XCheck("optIndicatorCount",1,s,errBuf))  optIndicatorCount=&d_optIndicatorCount;
    else { LOADIT(optIndicatorCount,"optIndicatorCount"); }  }
  { int s[]={3,4};
    if(!XCheck("optDotOptCount",1,s,errBuf))  optDotOptCount=&d_optDotOptCount;
    else { LOADIT(optDotOptCount,"optDotOptCount"); }  }
  { int s[]={3,3,3};
    if(!XCheck("optSetRefNr",2,s,errBuf))  optSetRefNr=&d_optSetRefNr;
    else { LOADIT(optSetRefNr,"optSetRefNr"); }  }
  { int s[]={3,11,3};
    if(!XCheck("optSetRefNrStr",2,s,errBuf))  optSetRefNrStr=&d_optSetRefNrStr;
    else { LOADIT(optSetRefNrStr,"optSetRefNrStr"); }  }
  { int s[]={3,3,3,12};
    if(!XCheck("optGetConstName",3,s,errBuf))  optGetConstName=&d_optGetConstName;
    else { LOADIT(optGetConstName,"optGetConstName"); }  }
  { int s[]={3,3,12};
    if(!XCheck("optGetTypeName",2,s,errBuf))  optGetTypeName=&d_optGetTypeName;
    else { LOADIT(optGetTypeName,"optGetTypeName"); }  }
  { int s[]={3,11};
    if(!XCheck("optLookUp",1,s,errBuf))  optLookUp=&d_optLookUp;
    else { LOADIT(optLookUp,"optLookUp"); }  }
  { int s[]={0,10};
    if(!XCheck("optReadFromPChar",1,s,errBuf))  optReadFromPChar=&d_optReadFromPChar;
    else { LOADIT(optReadFromPChar,"optReadFromPChar"); }  }
  { int s[]={3};
    if(!XCheck("optCount",0,s,errBuf))  optCount=&d_optCount;
    else LOADIT(optCount,"optCount");  }
  { int s[]={3};
    if(!XCheck("optMessageCount",0,s,errBuf))  optMessageCount=&d_optMessageCount;
    else LOADIT(optMessageCount,"optMessageCount");  }
  { int s[]={3};
    if(!XCheck("optGroupCount",0,s,errBuf))  optGroupCount=&d_optGroupCount;
    else LOADIT(optGroupCount,"optGroupCount");  }
  { int s[]={3};
    if(!XCheck("optRecentEnabled",0,s,errBuf))  optRecentEnabled=&d_optRecentEnabled;
    else LOADIT(optRecentEnabled,"optRecentEnabled");  }
  { int s[]={0,3};
    if(!XCheck("optRecentEnabledSet",1,s,errBuf))  optRecentEnabledSet=&d_optRecentEnabledSet;
    else   LOADIT(optRecentEnabledSet,"optRecentEnabledSet");  }

  return 0;

 symMissing:
  elen = errBufLen;  ebuf = errBuf;
  rc = sprintf (ebuf, "%.*s", elen, "Could not load symbol '");
  elen -= rc;  ebuf+= rc;
  rc = sprintf (ebuf, "%.*s", elen, symName);
  elen -= rc;  ebuf+= rc;
  rc = sprintf (ebuf, "%.*s", elen, "': ");
  elen -= rc;  ebuf+= rc;
  rc = sprintf (ebuf, "%.*s", elen, errMsg);
  elen -= rc;  ebuf+= rc;
  errBuf[errBufLen-1] = '\0';
  printf ("%s\n", errBuf);
  return 2;
} /* XLibraryLoad */


#if   defined(APIWRAP_LCASE_DECOR)  /* fortran names: lower case, trailing _ */
# define C_OPTCOUNT                    c_optcount_
# define C_OPTMESSAGECOUNT             c_optmessagecount_
# define C_OPTGROUPCOUNT               c_optgroupcount_
# define C_OPTRECENTENABLED            c_optrecentenabled_
# define C_OPTREADDEFINITION           c_optreaddefinition_
# define C_OPTREADPARAMETERFILE        c_optreadparameterfile_
# define C_OPTREADFROMSTR              c_optreadfromstr_
# define C_OPTWRITEPARAMETERFILE       c_optwriteparameterfile_
# define C_OPTCLEARMESSAGES            c_optclearmessages_
# define C_OPTADDMESSAGE               c_optaddmessage_
# define C_OPTGETMESSAGE               c_optgetmessage_
# define C_OPTRESETALL                 c_optresetall_
# define C_OPTRESETALLRECENT           c_optresetallrecent_
# define C_OPTRESETRECENTCHANGES       c_optresetrecentchanges_
# define C_OPTSHOWHELP                 c_optshowhelp_
# define C_OPTRESETNR                  c_optresetnr_
# define C_OPTFINDSTR                  c_optfindstr_
# define C_OPTGETINFONR                c_optgetinfonr_
# define C_OPTGETVALUESNR              c_optgetvaluesnr_
# define C_OPTSETVALUESNR              c_optsetvaluesnr_
# define C_OPTSETVALUES2NR             c_optsetvalues2nr_
# define C_OPTVERSION                  c_optversion_
# define C_OPTDEFINITIONFILE           c_optdefinitionfile_
# define C_OPTGETFROMANYSTRLIST        c_optgetfromanystrlist_
# define C_OPTGETFROMLISTSTR           c_optgetfromliststr_
# define C_OPTLISTCOUNTSTR             c_optlistcountstr_
# define C_OPTREADFROMLISTSTR          c_optreadfromliststr_
# define C_OPTSYNONYMCOUNT             c_optsynonymcount_
# define C_OPTGETSYNONYM               c_optgetsynonym_
# define C_OPTECHOSET                  c_optechoset_
# define C_OPTEOLONLYSET               c_opteolonlyset_
# define C_OPTNOBOUNDSSET              c_optnoboundsset_
# define C_OPTERRORCOUNT               c_opterrorcount_
# define C_OPTGETBOUNDSINT             c_optgetboundsint_
# define C_OPTGETBOUNDSDBL             c_optgetboundsdbl_
# define C_OPTGETDEFAULTSTR            c_optgetdefaultstr_
# define C_OPTGETINTNR                 c_optgetintnr_
# define C_OPTGETINT2NR                c_optgetint2nr_
# define C_OPTSETINTNR                 c_optsetintnr_
# define C_OPTSETINT2NR                c_optsetint2nr_
# define C_OPTGETSTRNR                 c_optgetstrnr_
# define C_OPTGETOPTHELPNR             c_optgetopthelpnr_
# define C_OPTGETENUMHELP              c_optgetenumhelp_
# define C_OPTGETENUMSTRNR             c_optgetenumstrnr_
# define C_OPTGETENUMCOUNT             c_optgetenumcount_
# define C_OPTGETENUMVALUE             c_optgetenumvalue_
# define C_OPTGETSTR2NR                c_optgetstr2nr_
# define C_OPTSETSTRNR                 c_optsetstrnr_
# define C_OPTSETSTR2NR                c_optsetstr2nr_
# define C_OPTGETDBLNR                 c_optgetdblnr_
# define C_OPTGETDBL2NR                c_optgetdbl2nr_
# define C_OPTSETDBLNR                 c_optsetdblnr_
# define C_OPTSETDBL2NR                c_optsetdbl2nr_
# define C_OPTGETVALSTR                c_optgetvalstr_
# define C_OPTGETVAL2STR               c_optgetval2str_
# define C_OPTGETNAMENR                c_optgetnamenr_
# define C_OPTGETDEFINEDNR             c_optgetdefinednr_
# define C_OPTGETHELPNR                c_optgethelpnr_
# define C_OPTGETGROUPNR               c_optgetgroupnr_
# define C_OPTGETGROUPGRPNR            c_optgetgroupgrpnr_
# define C_OPTGETOPTGROUPNR            c_optgetoptgroupnr_
# define C_OPTGETDOTOPTNR              c_optgetdotoptnr_
# define C_OPTGETDOTOPTUEL             c_optgetdotoptuel_
# define C_OPTGETINDICATORNR           c_optgetindicatornr_
# define C_OPTGETEQUINDICATORNR        c_optgetequindicatornr_
# define C_OPTGETVARINDICATORNR        c_optgetvarindicatornr_
# define C_OPTINDICATORCOUNT           c_optindicatorcount_
# define C_OPTDOTOPTCOUNT              c_optdotoptcount_
# define C_OPTSETREFNR                 c_optsetrefnr_
# define C_OPTSETREFNRSTR              c_optsetrefnrstr_
# define C_OPTGETCONSTNAME             c_optgetconstname_
# define C_OPTGETTYPENAME              c_optgettypename_
# define C_OPTLOOKUP                   c_optlookup_
# define C_OPTREADFROMPCHAR            c_optreadfrompchar_
# define C_OPTCREATE                   c_optcreate_
# define C_OPTCREATED                  c_optcreated_
# define C_OPTCREATEL                  c_optcreatel_
# define C_OPTGETREADY                 c_optgetready_
# define C_OPTGETREADYD                c_optgetreadyd_
# define C_OPTGETREADYL                c_optgetreadyl_
# define C_OPTEXIT                     c_optexit_
# define C_OPTFREE                     c_optfree_
# define C_OPTGETAPIERRORCOUNT         c_optgetapierrorcount_
# define C_OPTGETSCREENINDICATOR       c_optgetscreenindicator_
# define C_OPTSETSCREENINDICATOR       c_optsetscreenindicator_
# define C_OPTSETERRORCALLBACK         c_optseterrorcallback_
# define C_OPTRECENTENABLEDSET         c_optrecentenabledset_
#elif defined(APIWRAP_LCASE_NODECOR)/* fortran names: lower case, no _ */
# define C_OPTCOUNT                    c_optcount
# define C_OPTMESSAGECOUNT             c_optmessagecount
# define C_OPTGROUPCOUNT               c_optgroupcount
# define C_OPTRECENTENABLED            c_optrecentenabled
# define C_OPTREADDEFINITION           c_optreaddefinition
# define C_OPTREADPARAMETERFILE        c_optreadparameterfile
# define C_OPTREADFROMSTR              c_optreadfromstr
# define C_OPTWRITEPARAMETERFILE       c_optwriteparameterfile
# define C_OPTCLEARMESSAGES            c_optclearmessages
# define C_OPTADDMESSAGE               c_optaddmessage
# define C_OPTGETMESSAGE               c_optgetmessage
# define C_OPTRESETALL                 c_optresetall
# define C_OPTRESETALLRECENT           c_optresetallrecent
# define C_OPTRESETRECENTCHANGES       c_optresetrecentchanges
# define C_OPTSHOWHELP                 c_optshowhelp
# define C_OPTRESETNR                  c_optresetnr
# define C_OPTFINDSTR                  c_optfindstr
# define C_OPTGETINFONR                c_optgetinfonr
# define C_OPTGETVALUESNR              c_optgetvaluesnr
# define C_OPTSETVALUESNR              c_optsetvaluesnr
# define C_OPTSETVALUES2NR             c_optsetvalues2nr
# define C_OPTVERSION                  c_optversion
# define C_OPTDEFINITIONFILE           c_optdefinitionfile
# define C_OPTGETFROMANYSTRLIST        c_optgetfromanystrlist
# define C_OPTGETFROMLISTSTR           c_optgetfromliststr
# define C_OPTLISTCOUNTSTR             c_optlistcountstr
# define C_OPTREADFROMLISTSTR          c_optreadfromliststr
# define C_OPTSYNONYMCOUNT             c_optsynonymcount
# define C_OPTGETSYNONYM               c_optgetsynonym
# define C_OPTECHOSET                  c_optechoset
# define C_OPTEOLONLYSET               c_opteolonlyset
# define C_OPTNOBOUNDSSET              c_optnoboundsset
# define C_OPTERRORCOUNT               c_opterrorcount
# define C_OPTGETBOUNDSINT             c_optgetboundsint
# define C_OPTGETBOUNDSDBL             c_optgetboundsdbl
# define C_OPTGETDEFAULTSTR            c_optgetdefaultstr
# define C_OPTGETINTNR                 c_optgetintnr
# define C_OPTGETINT2NR                c_optgetint2nr
# define C_OPTSETINTNR                 c_optsetintnr
# define C_OPTSETINT2NR                c_optsetint2nr
# define C_OPTGETSTRNR                 c_optgetstrnr
# define C_OPTGETOPTHELPNR             c_optgetopthelpnr
# define C_OPTGETENUMHELP              c_optgetenumhelp
# define C_OPTGETENUMSTRNR             c_optgetenumstrnr
# define C_OPTGETENUMCOUNT             c_optgetenumcount
# define C_OPTGETENUMVALUE             c_optgetenumvalue
# define C_OPTGETSTR2NR                c_optgetstr2nr
# define C_OPTSETSTRNR                 c_optsetstrnr
# define C_OPTSETSTR2NR                c_optsetstr2nr
# define C_OPTGETDBLNR                 c_optgetdblnr
# define C_OPTGETDBL2NR                c_optgetdbl2nr
# define C_OPTSETDBLNR                 c_optsetdblnr
# define C_OPTSETDBL2NR                c_optsetdbl2nr
# define C_OPTGETVALSTR                c_optgetvalstr
# define C_OPTGETVAL2STR               c_optgetval2str
# define C_OPTGETNAMENR                c_optgetnamenr
# define C_OPTGETDEFINEDNR             c_optgetdefinednr
# define C_OPTGETHELPNR                c_optgethelpnr
# define C_OPTGETGROUPNR               c_optgetgroupnr
# define C_OPTGETGROUPGRPNR            c_optgetgroupgrpnr
# define C_OPTGETOPTGROUPNR            c_optgetoptgroupnr
# define C_OPTGETDOTOPTNR              c_optgetdotoptnr
# define C_OPTGETDOTOPTUEL             c_optgetdotoptuel
# define C_OPTGETINDICATORNR           c_optgetindicatornr
# define C_OPTGETEQUINDICATORNR        c_optgetequindicatornr
# define C_OPTGETVARINDICATORNR        c_optgetvarindicatornr
# define C_OPTINDICATORCOUNT           c_optindicatorcount
# define C_OPTDOTOPTCOUNT              c_optdotoptcount
# define C_OPTSETREFNR                 c_optsetrefnr
# define C_OPTSETREFNRSTR              c_optsetrefnrstr
# define C_OPTGETCONSTNAME             c_optgetconstname
# define C_OPTGETTYPENAME              c_optgettypename
# define C_OPTLOOKUP                   c_optlookup
# define C_OPTREADFROMPCHAR            c_optreadfrompchar
# define C_OPTCREATE                   c_optcreate
# define C_OPTCREATED                  c_optcreated
# define C_OPTCREATEL                  c_optcreatel
# define C_OPTGETREADY                 c_optgetready
# define C_OPTGETREADYD                c_optgetreadyd
# define C_OPTGETREADYL                c_optgetreadyl
# define C_OPTEXIT                     c_optexit
# define C_OPTFREE                     c_optfree
# define C_OPTGETAPIERRORCOUNT         c_optgetapierrorcount
# define C_OPTGETSCREENINDICATOR       c_optgetscreenindicator
# define C_OPTSETSCREENINDICATOR       c_optsetscreenindicator
# define C_OPTSETERRORCALLBACK         c_optseterrorcallback
# define C_OPTRECENTENABLEDSET         c_optrecentenabledset
#elif defined(APIWRAP_UCASE_DECOR)  /* fortran names: upper case, trailing _ */
# define C_OPTCOUNT                    C_OPTCOUNT_
# define C_OPTMESSAGECOUNT             C_OPTMESSAGECOUNT_
# define C_OPTGROUPCOUNT               C_OPTGROUPCOUNT_
# define C_OPTRECENTENABLED            C_OPTRECENTENABLED_
# define C_OPTREADDEFINITION           C_OPTREADDEFINITION_
# define C_OPTREADPARAMETERFILE        C_OPTREADPARAMETERFILE_
# define C_OPTREADFROMSTR              C_OPTREADFROMSTR_
# define C_OPTWRITEPARAMETERFILE       C_OPTWRITEPARAMETERFILE_
# define C_OPTCLEARMESSAGES            C_OPTCLEARMESSAGES_
# define C_OPTADDMESSAGE               C_OPTADDMESSAGE_
# define C_OPTGETMESSAGE               C_OPTGETMESSAGE_
# define C_OPTRESETALL                 C_OPTRESETALL_
# define C_OPTRESETALLRECENT           C_OPTRESETALLRECENT_
# define C_OPTRESETRECENTCHANGES       C_OPTRESETRECENTCHANGES_
# define C_OPTSHOWHELP                 C_OPTSHOWHELP_
# define C_OPTRESETNR                  C_OPTRESETNR_
# define C_OPTFINDSTR                  C_OPTFINDSTR_
# define C_OPTGETINFONR                C_OPTGETINFONR_
# define C_OPTGETVALUESNR              C_OPTGETVALUESNR_
# define C_OPTSETVALUESNR              C_OPTSETVALUESNR_
# define C_OPTSETVALUES2NR             C_OPTSETVALUES2NR_
# define C_OPTVERSION                  C_OPTVERSION_
# define C_OPTDEFINITIONFILE           C_OPTDEFINITIONFILE_
# define C_OPTGETFROMANYSTRLIST        C_OPTGETFROMANYSTRLIST_
# define C_OPTGETFROMLISTSTR           C_OPTGETFROMLISTSTR_
# define C_OPTLISTCOUNTSTR             C_OPTLISTCOUNTSTR_
# define C_OPTREADFROMLISTSTR          C_OPTREADFROMLISTSTR_
# define C_OPTSYNONYMCOUNT             C_OPTSYNONYMCOUNT_
# define C_OPTGETSYNONYM               C_OPTGETSYNONYM_
# define C_OPTECHOSET                  C_OPTECHOSET_
# define C_OPTEOLONLYSET               C_OPTEOLONLYSET_
# define C_OPTNOBOUNDSSET              C_OPTNOBOUNDSSET_
# define C_OPTERRORCOUNT               C_OPTERRORCOUNT_
# define C_OPTGETBOUNDSINT             C_OPTGETBOUNDSINT_
# define C_OPTGETBOUNDSDBL             C_OPTGETBOUNDSDBL_
# define C_OPTGETDEFAULTSTR            C_OPTGETDEFAULTSTR_
# define C_OPTGETINTNR                 C_OPTGETINTNR_
# define C_OPTGETINT2NR                C_OPTGETINT2NR_
# define C_OPTSETINTNR                 C_OPTSETINTNR_
# define C_OPTSETINT2NR                C_OPTSETINT2NR_
# define C_OPTGETSTRNR                 C_OPTGETSTRNR_
# define C_OPTGETOPTHELPNR             C_OPTGETOPTHELPNR_
# define C_OPTGETENUMHELP              C_OPTGETENUMHELP_
# define C_OPTGETENUMSTRNR             C_OPTGETENUMSTRNR_
# define C_OPTGETENUMCOUNT             C_OPTGETENUMCOUNT_
# define C_OPTGETENUMVALUE             C_OPTGETENUMVALUE_
# define C_OPTGETSTR2NR                C_OPTGETSTR2NR_
# define C_OPTSETSTRNR                 C_OPTSETSTRNR_
# define C_OPTSETSTR2NR                C_OPTSETSTR2NR_
# define C_OPTGETDBLNR                 C_OPTGETDBLNR_
# define C_OPTGETDBL2NR                C_OPTGETDBL2NR_
# define C_OPTSETDBLNR                 C_OPTSETDBLNR_
# define C_OPTSETDBL2NR                C_OPTSETDBL2NR_
# define C_OPTGETVALSTR                C_OPTGETVALSTR_
# define C_OPTGETVAL2STR               C_OPTGETVAL2STR_
# define C_OPTGETNAMENR                C_OPTGETNAMENR_
# define C_OPTGETDEFINEDNR             C_OPTGETDEFINEDNR_
# define C_OPTGETHELPNR                C_OPTGETHELPNR_
# define C_OPTGETGROUPNR               C_OPTGETGROUPNR_
# define C_OPTGETGROUPGRPNR            C_OPTGETGROUPGRPNR_
# define C_OPTGETOPTGROUPNR            C_OPTGETOPTGROUPNR_
# define C_OPTGETDOTOPTNR              C_OPTGETDOTOPTNR_
# define C_OPTGETDOTOPTUEL             C_OPTGETDOTOPTUEL_
# define C_OPTGETINDICATORNR           C_OPTGETINDICATORNR_
# define C_OPTGETEQUINDICATORNR        C_OPTGETEQUINDICATORNR_
# define C_OPTGETVARINDICATORNR        C_OPTGETVARINDICATORNR_
# define C_OPTINDICATORCOUNT           C_OPTINDICATORCOUNT_
# define C_OPTDOTOPTCOUNT              C_OPTDOTOPTCOUNT_
# define C_OPTSETREFNR                 C_OPTSETREFNR_
# define C_OPTSETREFNRSTR              C_OPTSETREFNRSTR_
# define C_OPTGETCONSTNAME             C_OPTGETCONSTNAME_
# define C_OPTGETTYPENAME              C_OPTGETTYPENAME_
# define C_OPTLOOKUP                   C_OPTLOOKUP_
# define C_OPTREADFROMPCHAR            C_OPTREADFROMPCHAR_
# define C_OPTCREATE                   C_OPTCREATE_
# define C_OPTCREATED                  C_OPTCREATED_
# define C_OPTCREATEL                  C_OPTCREATEL_
# define C_OPTGETREADY                 C_OPTGETREADY_
# define C_OPTGETREADYD                C_OPTGETREADYD_
# define C_OPTGETREADYL                C_OPTGETREADYL_
# define C_OPTEXIT                     C_OPTEXIT_
# define C_OPTFREE                     C_OPTFREE_
# define C_OPTGETAPIERRORCOUNT         C_OPTGETAPIERRORCOUNT_
# define C_OPTGETSCREENINDICATOR       C_OPTGETSCREENINDICATOR_
# define C_OPTSETSCREENINDICATOR       C_OPTSETSCREENINDICATOR_
# define C_OPTSETERRORCALLBACK         C_OPTSETERRORCALLBACK_
# define C_OPTRECENTENABLEDSET         C_OPTRECENTENABLEDSET_
#elif defined(APIWRAP_UCASE_NODECOR)/* fortran names: upper case, no _ */
# define C_OPTCOUNT                    C_OPTCOUNT
# define C_OPTMESSAGECOUNT             C_OPTMESSAGECOUNT
# define C_OPTGROUPCOUNT               C_OPTGROUPCOUNT
# define C_OPTRECENTENABLED            C_OPTRECENTENABLED
# define C_OPTREADDEFINITION           C_OPTREADDEFINITION
# define C_OPTREADPARAMETERFILE        C_OPTREADPARAMETERFILE
# define C_OPTREADFROMSTR              C_OPTREADFROMSTR
# define C_OPTWRITEPARAMETERFILE       C_OPTWRITEPARAMETERFILE
# define C_OPTCLEARMESSAGES            C_OPTCLEARMESSAGES
# define C_OPTADDMESSAGE               C_OPTADDMESSAGE
# define C_OPTGETMESSAGE               C_OPTGETMESSAGE
# define C_OPTRESETALL                 C_OPTRESETALL
# define C_OPTRESETALLRECENT           C_OPTRESETALLRECENT
# define C_OPTRESETRECENTCHANGES       C_OPTRESETRECENTCHANGES
# define C_OPTSHOWHELP                 C_OPTSHOWHELP
# define C_OPTRESETNR                  C_OPTRESETNR
# define C_OPTFINDSTR                  C_OPTFINDSTR
# define C_OPTGETINFONR                C_OPTGETINFONR
# define C_OPTGETVALUESNR              C_OPTGETVALUESNR
# define C_OPTSETVALUESNR              C_OPTSETVALUESNR
# define C_OPTSETVALUES2NR             C_OPTSETVALUES2NR
# define C_OPTVERSION                  C_OPTVERSION
# define C_OPTDEFINITIONFILE           C_OPTDEFINITIONFILE
# define C_OPTGETFROMANYSTRLIST        C_OPTGETFROMANYSTRLIST
# define C_OPTGETFROMLISTSTR           C_OPTGETFROMLISTSTR
# define C_OPTLISTCOUNTSTR             C_OPTLISTCOUNTSTR
# define C_OPTREADFROMLISTSTR          C_OPTREADFROMLISTSTR
# define C_OPTSYNONYMCOUNT             C_OPTSYNONYMCOUNT
# define C_OPTGETSYNONYM               C_OPTGETSYNONYM
# define C_OPTECHOSET                  C_OPTECHOSET
# define C_OPTEOLONLYSET               C_OPTEOLONLYSET
# define C_OPTNOBOUNDSSET              C_OPTNOBOUNDSSET
# define C_OPTERRORCOUNT               C_OPTERRORCOUNT
# define C_OPTGETBOUNDSINT             C_OPTGETBOUNDSINT
# define C_OPTGETBOUNDSDBL             C_OPTGETBOUNDSDBL
# define C_OPTGETDEFAULTSTR            C_OPTGETDEFAULTSTR
# define C_OPTGETINTNR                 C_OPTGETINTNR
# define C_OPTGETINT2NR                C_OPTGETINT2NR
# define C_OPTSETINTNR                 C_OPTSETINTNR
# define C_OPTSETINT2NR                C_OPTSETINT2NR
# define C_OPTGETSTRNR                 C_OPTGETSTRNR
# define C_OPTGETOPTHELPNR             C_OPTGETOPTHELPNR
# define C_OPTGETENUMHELP              C_OPTGETENUMHELP
# define C_OPTGETENUMSTRNR             C_OPTGETENUMSTRNR
# define C_OPTGETENUMCOUNT             C_OPTGETENUMCOUNT
# define C_OPTGETENUMVALUE             C_OPTGETENUMVALUE
# define C_OPTGETSTR2NR                C_OPTGETSTR2NR
# define C_OPTSETSTRNR                 C_OPTSETSTRNR
# define C_OPTSETSTR2NR                C_OPTSETSTR2NR
# define C_OPTGETDBLNR                 C_OPTGETDBLNR
# define C_OPTGETDBL2NR                C_OPTGETDBL2NR
# define C_OPTSETDBLNR                 C_OPTSETDBLNR
# define C_OPTSETDBL2NR                C_OPTSETDBL2NR
# define C_OPTGETVALSTR                C_OPTGETVALSTR
# define C_OPTGETVAL2STR               C_OPTGETVAL2STR
# define C_OPTGETNAMENR                C_OPTGETNAMENR
# define C_OPTGETDEFINEDNR             C_OPTGETDEFINEDNR
# define C_OPTGETHELPNR                C_OPTGETHELPNR
# define C_OPTGETGROUPNR               C_OPTGETGROUPNR
# define C_OPTGETGROUPGRPNR            C_OPTGETGROUPGRPNR
# define C_OPTGETOPTGROUPNR            C_OPTGETOPTGROUPNR
# define C_OPTGETDOTOPTNR              C_OPTGETDOTOPTNR
# define C_OPTGETDOTOPTUEL             C_OPTGETDOTOPTUEL
# define C_OPTGETINDICATORNR           C_OPTGETINDICATORNR
# define C_OPTGETEQUINDICATORNR        C_OPTGETEQUINDICATORNR
# define C_OPTGETVARINDICATORNR        C_OPTGETVARINDICATORNR
# define C_OPTINDICATORCOUNT           C_OPTINDICATORCOUNT
# define C_OPTDOTOPTCOUNT              C_OPTDOTOPTCOUNT
# define C_OPTSETREFNR                 C_OPTSETREFNR
# define C_OPTSETREFNRSTR              C_OPTSETREFNRSTR
# define C_OPTGETCONSTNAME             C_OPTGETCONSTNAME
# define C_OPTGETTYPENAME              C_OPTGETTYPENAME
# define C_OPTLOOKUP                   C_OPTLOOKUP
# define C_OPTREADFROMPCHAR            C_OPTREADFROMPCHAR
# define C_OPTCREATE                   C_OPTCREATE
# define C_OPTCREATED                  C_OPTCREATED
# define C_OPTCREATEL                  C_OPTCREATEL
# define C_OPTGETREADY                 C_OPTGETREADY
# define C_OPTGETREADYD                C_OPTGETREADYD
# define C_OPTGETREADYL                C_OPTGETREADYL
# define C_OPTEXIT                     C_OPTEXIT
# define C_OPTFREE                     C_OPTFREE
# define C_OPTGETAPIERRORCOUNT         C_OPTGETAPIERRORCOUNT
# define C_OPTGETSCREENINDICATOR       C_OPTGETSCREENINDICATOR
# define C_OPTSETSCREENINDICATOR       C_OPTSETSCREENINDICATOR
# define C_OPTSETERRORCALLBACK         C_OPTSETERRORCALLBACK
# define C_OPTRECENTENABLEDSET         C_OPTRECENTENABLEDSET
#else
#error "No compile define for fortran naming convention"
No_compile_define_for_fortran_naming_convention;
#endif


/* optGetReady: return false on failure, true on success */
static int optGetReady (char *msgBuf, int msgBufSize)
{
  if (! isLoaded) {
    isLoaded = ! XLibraryLoad (NULL, msgBuf, msgBufSize);
  }
  return isLoaded;
} /* optGetReady */

/* optGetReadyD: return false on failure to load library, true on success */
static int optGetReadyD (const char *dirName, char *msgBuf, int msgBufLen)
{
  int myrc = 0;

  if (! isLoaded) {
    isLoaded = ! XLibraryLoad (NULL, msgBuf, msgBufLen);
    if (isLoaded) {
      if (NULL != optSetLoadPath) {
        optSetLoadPath(dirName);
      }
      else {                            /* no setLoadPath call found */
        myrc |= 2;
      }
    }
    else {                              /* library load failed */
      myrc |= 1;
    }
  }
  return (myrc & 1) == 0;
} /* optGetReadyD */

/* optGetReadyL: return false on failure to load library, true on success */
static int optGetReadyL (const char *libName, char *msgBuf, int msgBufLen)
{
  char dirName[1024];
  int myrc = 0;
  char *p = NULL;

  if (! isLoaded) {
    isLoaded = ! XLibraryLoad (libName, msgBuf, msgBufLen);
    if (isLoaded) {
      if (NULL != optSetLoadPath) {
        /* get the dirname from libname */
        p = extractFileDir (libName, dirName, sizeof(dirName));
        if (NULL != p) {
          optSetLoadPath(dirName);
        }
        else {                          /* could not extract dirName */
          myrc |= 4;
        }
      }
      else {                            /* no setLoadPath call found */
        myrc |= 2;
      }
    }
    else {                              /* library load failed */
      myrc |= 1;
    }
  }
  return (myrc & 1) == 0;
} /* optGetReadyL */

/* optGetReady: return false on failure, true on success */
optBoolean_t OPT_CALLCONV
C_OPTGETREADY (char **msgBuf, int msgBufSiz)
{
  int optIsReady;
  optIsReady = optGetReady (*msgBuf, msgBufSiz);
  blankPad (*msgBuf, strlen(*msgBuf), msgBufSiz);
  return optIsReady;
} /* optGetReady */

/* optGetReadyD: return false on failure to load library, true on success */
optBoolean_t OPT_CALLCONV
C_OPTGETREADYD (char **dirName, int dirNameSiz, char **msgBuf, int msgBufSiz)
{
  int optIsReady;
  char dirNameC[512];
  convertF2C (*dirName, dirNameC, dirNameSiz, sizeof(dirNameC));
  **msgBuf = '\0';
  optIsReady = optGetReadyD (dirNameC, *msgBuf, msgBufSiz);
  blankPad (*msgBuf, strlen(*msgBuf), msgBufSiz);
  return optIsReady;
} /* optGetReadyD */

/* optGetReadyL: return false on failure to load library, true on success */
optBoolean_t OPT_CALLCONV
C_OPTGETREADYL (char **libName, int libNameSiz, char **msgBuf, int msgBufSiz)
{
  int optIsReady;
  char libNameC[512];
  convertF2C (*libName, libNameC, libNameSiz, sizeof(libNameC));
  **msgBuf = '\0';
  optIsReady = optGetReadyL (libNameC, *msgBuf, msgBufSiz);
  blankPad (*msgBuf, strlen(*msgBuf), msgBufSiz);
  return optIsReady;
} /* optGetReadyL */

/* optCreate: return false on failure, true on success */
optBoolean_t OPT_CALLCONV
C_OPTCREATE (u64_t *h, char **msgBuf, int msgBufSiz)
{
  int optIsReady;

  optIsReady = optGetReady (*msgBuf, msgBufSiz);
  blankPad (*msgBuf, strlen(*msgBuf), msgBufSiz);
  if (! optIsReady) {
    return 0;
  }
  assert(XCreate);
  XCreate(&(h->p));
  if(0 == h->i)
  { strcpy(*msgBuf,"Error while creating object"); return 0; }
  objectCount++;

  return 1;                     /* return true */
} /* optCreate */

/* optCreateD: return false on failure to load library, true on success */
optBoolean_t OPT_CALLCONV
C_OPTCREATED (u64_t *h, char **dirName, int dirNameSiz, char **msgBuf, int msgBufSiz)
{
  int optIsReady;
  char dirNameC[512];

  convertF2C (*dirName, dirNameC, dirNameSiz, sizeof(dirNameC));
  **msgBuf = '\0';
  optIsReady = optGetReadyD (dirNameC, *msgBuf, msgBufSiz);
  blankPad (*msgBuf, strlen(*msgBuf), msgBufSiz);
  if (! optIsReady) {
    return 0;
  }
  assert(XCreate);
  XCreate(&(h->p));
  if(0 == h->i)
  { strcpy(*msgBuf,"Error while creating object"); return 0; }
  objectCount++;

  return 1;                     /* return true */
} /* optCreateD */

/* optCreateL: return false on failure to load library, true on success */
optBoolean_t OPT_CALLCONV
C_OPTCREATEL (u64_t *h, char **libName, int libNameSiz, char **msgBuf, int msgBufSiz)
{
  int optIsReady;
  char libNameC[512];

  convertF2C (*libName, libNameC, libNameSiz, sizeof(libNameC));
  **msgBuf = '\0';
  optIsReady = optGetReadyL (libNameC, *msgBuf, msgBufSiz);
  blankPad (*msgBuf, strlen(*msgBuf), msgBufSiz);
  if (! optIsReady) {
    return 0;
  }
  assert(XCreate);
  XCreate(&(h->p));
  if(0 == h->i)
  { strcpy(*msgBuf,"Error while creating object"); return 0; }
  objectCount++;

  return 1;                     /* return true */
} /* optCreateL */

void OPT_CALLCONV
C_OPTEXIT (int i)
{
  exit (i);
} /* optExit */

optBoolean_t OPT_CALLCONV
C_OPTFREE (u64_t *h)
{
  assert(XFree);
  XFree(&(h->p));
  objectCount--;
  if (isLoaded && 0 == objectCount) {
    (void) unLoadLib (hLibGlobal);
    isLoaded = 0;
  }
  return 1;
} /* optFree */

int OPT_CALLCONV
C_OPTGETSCREENINDICATOR ()
{
  return screenIndicator;
} /* optGetScreenIndicator */

void OPT_CALLCONV
C_OPTSETSCREENINDICATOR (int scrInd)
{
  screenIndicator = scrInd;
  return;
} /* optSetScreenIndicator */

void OPT_CALLCONV
C_OPTSETERRORCALLBACK(errorCallbackFort_t func)
{
  errorCallbackFort = func;
} /* optSetErrorCallback */

int OPT_CALLCONV
C_OPTGETAPIERRORCOUNT ()
{
  return APIErrorCount;
} /* optGetAPIErrorCount */


/* start implementation of glue code for functions */

int OPT_CALLCONV
C_OPTREADDEFINITION (INT64 iptr_, const char **fn, int len_fn)
{
  u64_t h_;
  int result;
  string255 pas_fn;

  h_.i = iptr_;
  convertF2PAS(*fn, pas_fn, len_fn, 255);
  result = optReadDefinition(h_.p,pas_fn);
  return result;
}

int OPT_CALLCONV
C_OPTREADPARAMETERFILE (INT64 iptr_, const char **fn, int len_fn)
{
  u64_t h_;
  int result;
  string255 pas_fn;

  h_.i = iptr_;
  convertF2PAS(*fn, pas_fn, len_fn, 255);
  result = optReadParameterFile(h_.p,pas_fn);
  return result;
}

void OPT_CALLCONV
C_OPTREADFROMSTR (INT64 iptr_, const char **s, int len_s)
{
  u64_t h_;
  string255 pas_s;

  h_.i = iptr_;
  convertF2PAS(*s, pas_s, len_s, 255);
  optReadFromStr(h_.p,pas_s);
}

int OPT_CALLCONV
C_OPTWRITEPARAMETERFILE (INT64 iptr_, const char **fn, int len_fn)
{
  u64_t h_;
  int result;
  string255 pas_fn;

  h_.i = iptr_;
  convertF2PAS(*fn, pas_fn, len_fn, 255);
  result = optWriteParameterFile(h_.p,pas_fn);
  return result;
}

void OPT_CALLCONV
C_OPTCLEARMESSAGES (INT64 iptr_)
{
  u64_t h_;

  h_.i = iptr_;
  optClearMessages(h_.p);
}

void OPT_CALLCONV
C_OPTADDMESSAGE (INT64 iptr_, const char **info, int len_info)
{
  u64_t h_;
  string255 pas_info;

  h_.i = iptr_;
  convertF2PAS(*info, pas_info, len_info, 255);
  optAddMessage(h_.p,pas_info);
}

void OPT_CALLCONV
C_OPTGETMESSAGE (INT64 iptr_, int N, char **info, int len_info, int *iType)
{
  u64_t h_;
  string255 pas_info;

  h_.i = iptr_;
  optGetMessage(h_.p,N,pas_info,iType);
  convertPAS2F(pas_info, *info, len_info);
}

void OPT_CALLCONV
C_OPTRESETALL (INT64 iptr_)
{
  u64_t h_;

  h_.i = iptr_;
  optResetAll(h_.p);
}

void OPT_CALLCONV
C_OPTRESETALLRECENT (INT64 iptr_)
{
  u64_t h_;

  h_.i = iptr_;
  optResetAllRecent(h_.p);
}

void OPT_CALLCONV
C_OPTRESETRECENTCHANGES (INT64 iptr_)
{
  u64_t h_;

  h_.i = iptr_;
  optResetRecentChanges(h_.p);
}

void OPT_CALLCONV
C_OPTSHOWHELP (INT64 iptr_, const char **HlpID, int len_HlpID)
{
  u64_t h_;
  string255 pas_HlpID;

  h_.i = iptr_;
  convertF2PAS(*HlpID, pas_HlpID, len_HlpID, 255);
  optShowHelp(h_.p,pas_HlpID);
}

int OPT_CALLCONV
C_OPTRESETNR (INT64 iptr_, int ANr)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optResetNr(h_.p,ANr);
  return result;
}

int OPT_CALLCONV
C_OPTFINDSTR (INT64 iptr_, const char **AName, int len_AName, int *ANr, int *ARefNr)
{
  u64_t h_;
  int result;
  string255 pas_AName;

  h_.i = iptr_;
  convertF2PAS(*AName, pas_AName, len_AName, 255);
  result = optFindStr(h_.p,pas_AName,ANr,ARefNr);
  return result;
}

int OPT_CALLCONV
C_OPTGETINFONR (INT64 iptr_, int ANr, int *ADefined, int *ADefinedR, int *ARefNr, int *ADataType, int *AOptType, int *ASubType)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetInfoNr(h_.p,ANr,ADefined,ADefinedR,ARefNr,ADataType,AOptType,ASubType);
  return result;
}

int OPT_CALLCONV
C_OPTGETVALUESNR (INT64 iptr_, int ANr, char **ASName, int len_ASName, int *AIVal, double *ADVal, char **ASVal, int len_ASVal)
{
  u64_t h_;
  int result;
  string255 pas_ASName;
  string255 pas_ASVal;

  h_.i = iptr_;
  result = optGetValuesNr(h_.p,ANr,pas_ASName,AIVal,ADVal,pas_ASVal);
  convertPAS2F(pas_ASName, *ASName, len_ASName);
  convertPAS2F(pas_ASVal, *ASVal, len_ASVal);
  return result;
}

int OPT_CALLCONV
C_OPTSETVALUESNR (INT64 iptr_, int ANr, int AIVal, double ADVal, const char **ASVal, int len_ASVal)
{
  u64_t h_;
  int result;
  string255 pas_ASVal;

  h_.i = iptr_;
  convertF2PAS(*ASVal, pas_ASVal, len_ASVal, 255);
  result = optSetValuesNr(h_.p,ANr,AIVal,ADVal,pas_ASVal);
  return result;
}

int OPT_CALLCONV
C_OPTSETVALUES2NR (INT64 iptr_, int ANr, int AIVal, double ADVal, const char **ASVal, int len_ASVal)
{
  u64_t h_;
  int result;
  string255 pas_ASVal;

  h_.i = iptr_;
  convertF2PAS(*ASVal, pas_ASVal, len_ASVal, 255);
  result = optSetValues2Nr(h_.p,ANr,AIVal,ADVal,pas_ASVal);
  return result;
}

void OPT_CALLCONV
C_OPTVERSION (INT64 iptr_, char **sversion, int len_sversion)
{
  u64_t h_;
  string255 pas_sversion;

  h_.i = iptr_;
  optVersion(h_.p,pas_sversion);
  convertPAS2F(pas_sversion, *sversion, len_sversion);
}

void OPT_CALLCONV
C_OPTDEFINITIONFILE (INT64 iptr_, char **sfilename, int len_sfilename)
{
  u64_t h_;
  string255 pas_sfilename;

  h_.i = iptr_;
  optDefinitionFile(h_.p,pas_sfilename);
  convertPAS2F(pas_sfilename, *sfilename, len_sfilename);
}

int OPT_CALLCONV
C_OPTGETFROMANYSTRLIST (INT64 iptr_, int idash, char **skey, int len_skey, char **sval, int len_sval)
{
  u64_t h_;
  int result;
  string255 pas_skey;
  string255 pas_sval;

  h_.i = iptr_;
  result = optGetFromAnyStrList(h_.p,idash,pas_skey,pas_sval);
  convertPAS2F(pas_skey, *skey, len_skey);
  convertPAS2F(pas_sval, *sval, len_sval);
  return result;
}

int OPT_CALLCONV
C_OPTGETFROMLISTSTR (INT64 iptr_, const char **skey, int len_skey, char **sval, int len_sval)
{
  u64_t h_;
  int result;
  string255 pas_skey;
  string255 pas_sval;

  h_.i = iptr_;
  convertF2PAS(*skey, pas_skey, len_skey, 255);
  result = optGetFromListStr(h_.p,pas_skey,pas_sval);
  convertPAS2F(pas_sval, *sval, len_sval);
  return result;
}

int OPT_CALLCONV
C_OPTLISTCOUNTSTR (INT64 iptr_, const char **skey, int len_skey)
{
  u64_t h_;
  int result;
  string255 pas_skey;

  h_.i = iptr_;
  convertF2PAS(*skey, pas_skey, len_skey, 255);
  result = optListCountStr(h_.p,pas_skey);
  return result;
}

int OPT_CALLCONV
C_OPTREADFROMLISTSTR (INT64 iptr_, const char **skey, int len_skey, int iPos, char **sval, int len_sval)
{
  u64_t h_;
  int result;
  string255 pas_skey;
  string255 pas_sval;

  h_.i = iptr_;
  convertF2PAS(*skey, pas_skey, len_skey, 255);
  result = optReadFromListStr(h_.p,pas_skey,iPos,pas_sval);
  convertPAS2F(pas_sval, *sval, len_sval);
  return result;
}

int OPT_CALLCONV
C_OPTSYNONYMCOUNT (INT64 iptr_)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optSynonymCount(h_.p);
  return result;
}

int OPT_CALLCONV
C_OPTGETSYNONYM (INT64 iptr_, int N, char **SSyn, int len_SSyn, char **SName, int len_SName)
{
  u64_t h_;
  int result;
  string255 pas_SSyn;
  string255 pas_SName;

  h_.i = iptr_;
  result = optGetSynonym(h_.p,N,pas_SSyn,pas_SName);
  convertPAS2F(pas_SSyn, *SSyn, len_SSyn);
  convertPAS2F(pas_SName, *SName, len_SName);
  return result;
}

void OPT_CALLCONV
C_OPTECHOSET (INT64 iptr_, int V)
{
  u64_t h_;

  h_.i = iptr_;
  optEchoSet(h_.p,V);
}

int OPT_CALLCONV
C_OPTEOLONLYSET (INT64 iptr_, int ival)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optEOLOnlySet(h_.p,ival);
  return result;
}

void OPT_CALLCONV
C_OPTNOBOUNDSSET (INT64 iptr_, int ival)
{
  u64_t h_;

  h_.i = iptr_;
  optNoBoundsSet(h_.p,ival);
}

void OPT_CALLCONV
C_OPTERRORCOUNT (INT64 iptr_, int *iErrors, int *iWarnings)
{
  u64_t h_;

  h_.i = iptr_;
  optErrorCount(h_.p,iErrors,iWarnings);
}

int OPT_CALLCONV
C_OPTGETBOUNDSINT (INT64 iptr_, int ANr, int *ilval, int *ihval, int *idval)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetBoundsInt(h_.p,ANr,ilval,ihval,idval);
  return result;
}

int OPT_CALLCONV
C_OPTGETBOUNDSDBL (INT64 iptr_, int ANr, double *dlval, double *dhval, double *ddval)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetBoundsDbl(h_.p,ANr,dlval,dhval,ddval);
  return result;
}

int OPT_CALLCONV
C_OPTGETDEFAULTSTR (INT64 iptr_, int ANr, char **sval, int len_sval)
{
  u64_t h_;
  int result;
  string255 pas_sval;

  h_.i = iptr_;
  result = optGetDefaultStr(h_.p,ANr,pas_sval);
  convertPAS2F(pas_sval, *sval, len_sval);
  return result;
}

int OPT_CALLCONV
C_OPTGETINTNR (INT64 iptr_, int ANr, int *AIVal)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetIntNr(h_.p,ANr,AIVal);
  return result;
}

int OPT_CALLCONV
C_OPTGETINT2NR (INT64 iptr_, int ANr, int *AIVal)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetInt2Nr(h_.p,ANr,AIVal);
  return result;
}

int OPT_CALLCONV
C_OPTSETINTNR (INT64 iptr_, int ANr, int AIVal)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optSetIntNr(h_.p,ANr,AIVal);
  return result;
}

int OPT_CALLCONV
C_OPTSETINT2NR (INT64 iptr_, int ANr, int AIVal)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optSetInt2Nr(h_.p,ANr,AIVal);
  return result;
}

int OPT_CALLCONV
C_OPTGETSTRNR (INT64 iptr_, int ANr, char **ASVal, int len_ASVal)
{
  u64_t h_;
  int result;
  string255 pas_ASVal;

  h_.i = iptr_;
  result = optGetStrNr(h_.p,ANr,pas_ASVal);
  convertPAS2F(pas_ASVal, *ASVal, len_ASVal);
  return result;
}

int OPT_CALLCONV
C_OPTGETOPTHELPNR (INT64 iptr_, int ANr, char **AName, int len_AName, int *AHc, int *AGroup)
{
  u64_t h_;
  int result;
  string255 pas_AName;

  h_.i = iptr_;
  result = optGetOptHelpNr(h_.p,ANr,pas_AName,AHc,AGroup);
  convertPAS2F(pas_AName, *AName, len_AName);
  return result;
}

int OPT_CALLCONV
C_OPTGETENUMHELP (INT64 iptr_, int ANr, int AOrd, int *AHc, char **AHelpStr, int len_AHelpStr)
{
  u64_t h_;
  int result;
  string255 pas_AHelpStr;

  h_.i = iptr_;
  result = optGetEnumHelp(h_.p,ANr,AOrd,AHc,pas_AHelpStr);
  convertPAS2F(pas_AHelpStr, *AHelpStr, len_AHelpStr);
  return result;
}

int OPT_CALLCONV
C_OPTGETENUMSTRNR (INT64 iptr_, int ANr, char **ASVal, int len_ASVal, int *AOrd)
{
  u64_t h_;
  int result;
  string255 pas_ASVal;

  h_.i = iptr_;
  result = optGetEnumStrNr(h_.p,ANr,pas_ASVal,AOrd);
  convertPAS2F(pas_ASVal, *ASVal, len_ASVal);
  return result;
}

int OPT_CALLCONV
C_OPTGETENUMCOUNT (INT64 iptr_, int ANr, int *ACount)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetEnumCount(h_.p,ANr,ACount);
  return result;
}

int OPT_CALLCONV
C_OPTGETENUMVALUE (INT64 iptr_, int ANr, int AOrd, int *AValInt, char **AValStr, int len_AValStr)
{
  u64_t h_;
  int result;
  string255 pas_AValStr;

  h_.i = iptr_;
  result = optGetEnumValue(h_.p,ANr,AOrd,AValInt,pas_AValStr);
  convertPAS2F(pas_AValStr, *AValStr, len_AValStr);
  return result;
}

int OPT_CALLCONV
C_OPTGETSTR2NR (INT64 iptr_, int ANr, char **ASVal, int len_ASVal)
{
  u64_t h_;
  int result;
  string255 pas_ASVal;

  h_.i = iptr_;
  result = optGetStr2Nr(h_.p,ANr,pas_ASVal);
  convertPAS2F(pas_ASVal, *ASVal, len_ASVal);
  return result;
}

int OPT_CALLCONV
C_OPTSETSTRNR (INT64 iptr_, int ANr, const char **ASVal, int len_ASVal)
{
  u64_t h_;
  int result;
  string255 pas_ASVal;

  h_.i = iptr_;
  convertF2PAS(*ASVal, pas_ASVal, len_ASVal, 255);
  result = optSetStrNr(h_.p,ANr,pas_ASVal);
  return result;
}

int OPT_CALLCONV
C_OPTSETSTR2NR (INT64 iptr_, int ANr, const char **ASVal, int len_ASVal)
{
  u64_t h_;
  int result;
  string255 pas_ASVal;

  h_.i = iptr_;
  convertF2PAS(*ASVal, pas_ASVal, len_ASVal, 255);
  result = optSetStr2Nr(h_.p,ANr,pas_ASVal);
  return result;
}

int OPT_CALLCONV
C_OPTGETDBLNR (INT64 iptr_, int ANr, double *ADVal)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetDblNr(h_.p,ANr,ADVal);
  return result;
}

int OPT_CALLCONV
C_OPTGETDBL2NR (INT64 iptr_, int ANr, double *ADVal)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetDbl2Nr(h_.p,ANr,ADVal);
  return result;
}

int OPT_CALLCONV
C_OPTSETDBLNR (INT64 iptr_, int ANr, double ADVal)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optSetDblNr(h_.p,ANr,ADVal);
  return result;
}

int OPT_CALLCONV
C_OPTSETDBL2NR (INT64 iptr_, int ANr, double ADVal)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optSetDbl2Nr(h_.p,ANr,ADVal);
  return result;
}

int OPT_CALLCONV
C_OPTGETVALSTR (INT64 iptr_, const char **AName, int len_AName, char **ASVal, int len_ASVal)
{
  u64_t h_;
  int result;
  string255 pas_AName;
  string255 pas_ASVal;

  h_.i = iptr_;
  convertF2PAS(*AName, pas_AName, len_AName, 255);
  result = optGetValStr(h_.p,pas_AName,pas_ASVal);
  convertPAS2F(pas_ASVal, *ASVal, len_ASVal);
  return result;
}

int OPT_CALLCONV
C_OPTGETVAL2STR (INT64 iptr_, const char **AName, int len_AName, char **ASVal, int len_ASVal)
{
  u64_t h_;
  int result;
  string255 pas_AName;
  string255 pas_ASVal;

  h_.i = iptr_;
  convertF2PAS(*AName, pas_AName, len_AName, 255);
  result = optGetVal2Str(h_.p,pas_AName,pas_ASVal);
  convertPAS2F(pas_ASVal, *ASVal, len_ASVal);
  return result;
}

int OPT_CALLCONV
C_OPTGETNAMENR (INT64 iptr_, int ANr, char **ASName, int len_ASName)
{
  u64_t h_;
  int result;
  string255 pas_ASName;

  h_.i = iptr_;
  result = optGetNameNr(h_.p,ANr,pas_ASName);
  convertPAS2F(pas_ASName, *ASName, len_ASName);
  return result;
}

int OPT_CALLCONV
C_OPTGETDEFINEDNR (INT64 iptr_, int ANr, int *AIVal)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetDefinedNr(h_.p,ANr,AIVal);
  return result;
}

int OPT_CALLCONV
C_OPTGETHELPNR (INT64 iptr_, int ANr, char **ASOpt, int len_ASOpt, char **ASHelp, int len_ASHelp)
{
  u64_t h_;
  int result;
  string255 pas_ASOpt;
  string255 pas_ASHelp;

  h_.i = iptr_;
  result = optGetHelpNr(h_.p,ANr,pas_ASOpt,pas_ASHelp);
  convertPAS2F(pas_ASOpt, *ASOpt, len_ASOpt);
  convertPAS2F(pas_ASHelp, *ASHelp, len_ASHelp);
  return result;
}

int OPT_CALLCONV
C_OPTGETGROUPNR (INT64 iptr_, int ANr, char **AName, int len_AName, int *AGroup, int *AHc, char **AHelp, int len_AHelp)
{
  u64_t h_;
  int result;
  string255 pas_AName;
  string255 pas_AHelp;

  h_.i = iptr_;
  result = optGetGroupNr(h_.p,ANr,pas_AName,AGroup,AHc,pas_AHelp);
  convertPAS2F(pas_AName, *AName, len_AName);
  convertPAS2F(pas_AHelp, *AHelp, len_AHelp);
  return result;
}

int OPT_CALLCONV
C_OPTGETGROUPGRPNR (INT64 iptr_, int AGroup)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetGroupGrpNr(h_.p,AGroup);
  return result;
}

int OPT_CALLCONV
C_OPTGETOPTGROUPNR (INT64 iptr_, int ANr)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optGetOptGroupNr(h_.p,ANr);
  return result;
}

int OPT_CALLCONV
C_OPTGETDOTOPTNR (INT64 iptr_, int ANr, char **AName, int len_AName, int *AObjNr, int *ADim, double *AValue)
{
  u64_t h_;
  int result;
  string255 pas_AName;

  h_.i = iptr_;
  result = optGetDotOptNr(h_.p,ANr,pas_AName,AObjNr,ADim,AValue);
  convertPAS2F(pas_AName, *AName, len_AName);
  return result;
}

int OPT_CALLCONV
C_OPTGETDOTOPTUEL (INT64 iptr_, int ANr, int ADim, char **AUEL, int len_AUEL)
{
  u64_t h_;
  int result;
  string255 pas_AUEL;

  h_.i = iptr_;
  result = optGetDotOptUel(h_.p,ANr,ADim,pas_AUEL);
  convertPAS2F(pas_AUEL, *AUEL, len_AUEL);
  return result;
}

int OPT_CALLCONV
C_OPTGETINDICATORNR (INT64 iptr_, int ANr, char **EquName, int len_EquName, char **VarName, int len_VarName, int *EquDim, int *VarDim, int *AValue)
{
  u64_t h_;
  int result;
  string255 pas_EquName;
  string255 pas_VarName;

  h_.i = iptr_;
  result = optGetIndicatorNr(h_.p,ANr,pas_EquName,pas_VarName,EquDim,VarDim,AValue);
  convertPAS2F(pas_EquName, *EquName, len_EquName);
  convertPAS2F(pas_VarName, *VarName, len_VarName);
  return result;
}

int OPT_CALLCONV
C_OPTGETEQUINDICATORNR (INT64 iptr_, int ANr, int ADim, char **AIndex, int len_AIndex)
{
  u64_t h_;
  int result;
  string255 pas_AIndex;

  h_.i = iptr_;
  result = optGetEquIndicatorNr(h_.p,ANr,ADim,pas_AIndex);
  convertPAS2F(pas_AIndex, *AIndex, len_AIndex);
  return result;
}

int OPT_CALLCONV
C_OPTGETVARINDICATORNR (INT64 iptr_, int ANr, int ADim, char **AIndex, int len_AIndex)
{
  u64_t h_;
  int result;
  string255 pas_AIndex;

  h_.i = iptr_;
  result = optGetVarIndicatorNr(h_.p,ANr,ADim,pas_AIndex);
  convertPAS2F(pas_AIndex, *AIndex, len_AIndex);
  return result;
}

int OPT_CALLCONV
C_OPTINDICATORCOUNT (INT64 iptr_, int *ANrErrors)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optIndicatorCount(h_.p,ANrErrors);
  return result;
}

int OPT_CALLCONV
C_OPTDOTOPTCOUNT (INT64 iptr_, int *ANrErrors)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optDotOptCount(h_.p,ANrErrors);
  return result;
}

int OPT_CALLCONV
C_OPTSETREFNR (INT64 iptr_, int ANr, int AValue)
{
  u64_t h_;
  int result;

  h_.i = iptr_;
  result = optSetRefNr(h_.p,ANr,AValue);
  return result;
}

int OPT_CALLCONV
C_OPTSETREFNRSTR (INT64 iptr_, const char **AOpt, int len_AOpt, int AValue)
{
  u64_t h_;
  int result;
  string255 pas_AOpt;

  h_.i = iptr_;
  convertF2PAS(*AOpt, pas_AOpt, len_AOpt, 255);
  result = optSetRefNrStr(h_.p,pas_AOpt,AValue);
  return result;
}

int OPT_CALLCONV
C_OPTGETCONSTNAME (INT64 iptr_, int cgroup, int cindex, char **cname, int len_cname)
{
  u64_t h_;
  int result;
  string255 pas_cname;

  h_.i = iptr_;
  result = optGetConstName(h_.p,cgroup,cindex,pas_cname);
  convertPAS2F(pas_cname, *cname, len_cname);
  return result;
}

int OPT_CALLCONV
C_OPTGETTYPENAME (INT64 iptr_, int TNr, char **sTName, int len_sTName)
{
  u64_t h_;
  int result;
  string255 pas_sTName;

  h_.i = iptr_;
  result = optGetTypeName(h_.p,TNr,pas_sTName);
  convertPAS2F(pas_sTName, *sTName, len_sTName);
  return result;
}

int OPT_CALLCONV
C_OPTLOOKUP (INT64 iptr_, const char **AOpt, int len_AOpt)
{
  u64_t h_;
  int result;
  string255 pas_AOpt;

  h_.i = iptr_;
  convertF2PAS(*AOpt, pas_AOpt, len_AOpt, 255);
  result = optLookUp(h_.p,pas_AOpt);
  return result;
}

void OPT_CALLCONV
C_OPTREADFROMPCHAR (INT64 iptr_, char **p, int len_p)
{
  u64_t h_;
  cBuf512_t c_p;

  h_.i = iptr_;
  optReadFromPChar(h_.p,c_p);
  convertC2F(c_p, *p, len_p);
}

/* start implementation of glue code for properties */

int OPT_CALLCONV
C_OPTCOUNT (INT64 iptr)
{
  u64_t h;

  h.i = iptr;
  return optCount(h.p);
}

int OPT_CALLCONV
C_OPTMESSAGECOUNT (INT64 iptr)
{
  u64_t h;

  h.i = iptr;
  return optMessageCount(h.p);
}

int OPT_CALLCONV
C_OPTGROUPCOUNT (INT64 iptr)
{
  u64_t h;

  h.i = iptr;
  return optGroupCount(h.p);
}

int OPT_CALLCONV
C_OPTRECENTENABLED (INT64 iptr)
{
  u64_t h;

  h.i = iptr;
  return optRecentEnabled(h.p);
}

void OPT_CALLCONV
C_OPTRECENTENABLEDSET (INT64 iptr, int x)
{
  u64_t h;

  h.i = iptr;
  optRecentEnabledSet(h.p,x);
}

