/*  Java Native Interrface code generated by apiwrapper */

#include <jni.h>
#include <stdio.h>
#include <string.h>
#include <optcc.h>
#include <windows.h>

typedef char string255[256];

static void printerr(const char *mess, const char*name)
{
   fprintf(stderr,"%s: %s\n",mess,name);
   exit(1);
}

static JavaVM *Cached_JVM = NULL;
JNIEXPORT jint JNICALL JNI_OnLoad(JavaVM *vm, void *reserved)
{
    Cached_JVM = vm;
    return JNI_VERSION_1_2;
}

static char* getMethodName_(const char* name)
{
    char *s;
    s = strrchr(name,'.');
    if (s==NULL)
        return NULL;
    ++s;
    return strdup(s);
}

static char* getClassName_(const char* name)
{
    char *s;
    char *t;
    t = strdup(name);
    s = strrchr(t,'.');
    if (s==NULL)
        return NULL;
    *s = '\0';
    return t;
}

JNIEXPORT jint JNICALL Java_optjava_GetReady(JNIEnv *env, jobject obj, jobjectArray msg)
{
   int rc_GetReady;
   jstring local_msg;
   char buffer_msg[256];
   rc_GetReady = optGetReady(buffer_msg, sizeof(buffer_msg));
   local_msg = (*env)->NewStringUTF(env, buffer_msg);
   (*env)->SetObjectArrayElement(env, msg, 0, local_msg);
   return rc_GetReady;
}

JNIEXPORT jint JNICALL Java_optjava_GetReadyD(JNIEnv *env, jobject obj, jstring dirName, jobjectArray msg)
{
   int rc_GetReadyD;
   char *local_dirName;
   jstring local_msg;
   char buffer_msg[256];
   buffer_msg[0] = '\0';
   local_dirName = (char *) (*env)->GetStringUTFChars(env, dirName, NULL);
   rc_GetReadyD = optGetReadyD(local_dirName, buffer_msg, sizeof(buffer_msg));
   (*env)->ReleaseStringUTFChars(env, dirName, local_dirName);
   local_msg = (*env)->NewStringUTF(env, buffer_msg);
   (*env)->SetObjectArrayElement(env, msg, 0, local_msg);
   return rc_GetReadyD;
}

JNIEXPORT jint JNICALL Java_optjava_GetReadyL(JNIEnv *env, jobject obj, jstring libName, jobjectArray msg)
{
   int rc_GetReadyL;
   char *local_libName;
   jstring local_msg;
   char buffer_msg[256];
   buffer_msg[0] = '\0';
   local_libName = (char *) (*env)->GetStringUTFChars(env, libName, NULL);
   rc_GetReadyL = optGetReadyL(local_libName, buffer_msg, sizeof(buffer_msg));
   (*env)->ReleaseStringUTFChars(env, libName, local_libName);
   local_msg = (*env)->NewStringUTF(env, buffer_msg);
   (*env)->SetObjectArrayElement(env, msg, 0, local_msg);
   return rc_GetReadyL;
}

JNIEXPORT jint JNICALL Java_optjava_Create(JNIEnv *env, jobject obj, jobjectArray msg)
{
   int rc_Create;
   jfieldID fid;
   int popt;
   jstring local_msg;
   char buffer_msg[256];
   jclass cls = (*env)->GetObjectClass(env, obj);
   buffer_msg[0] = '\0';
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_Create = optCreate((optHandle_t *)&popt, buffer_msg, sizeof(buffer_msg));
   local_msg = (*env)->NewStringUTF(env, buffer_msg);
   (*env)->SetObjectArrayElement(env, msg, 0, local_msg);
   (*env)->SetIntField(env, obj, fid, popt);
   return rc_Create;
}

JNIEXPORT jint JNICALL Java_optjava_CreateD(JNIEnv *env, jobject obj, jstring dirName, jobjectArray msg)
{
   int rc_CreateD;
   jfieldID fid;
   int popt;
   char *local_dirName;
   jstring local_msg;
   char buffer_msg[256];
   jclass cls = (*env)->GetObjectClass(env, obj);
   buffer_msg[0] = '\0';
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_dirName = (char *) (*env)->GetStringUTFChars(env, dirName, NULL);
   rc_CreateD = optCreateD((optHandle_t *)&popt, local_dirName, buffer_msg, sizeof(buffer_msg));
   (*env)->ReleaseStringUTFChars(env, dirName, local_dirName);
   local_msg = (*env)->NewStringUTF(env, buffer_msg);
   (*env)->SetObjectArrayElement(env, msg, 0, local_msg);
   (*env)->SetIntField(env, obj, fid, popt);
   return rc_CreateD;
}

JNIEXPORT jint JNICALL Java_optjava_CreateL(JNIEnv *env, jobject obj, jstring libName, jobjectArray msg)
{
   int rc_CreateL;
   jfieldID fid;
   int popt;
   char *local_libName;
   jstring local_msg;
   char buffer_msg[256];
   jclass cls = (*env)->GetObjectClass(env, obj);
   buffer_msg[0] = '\0';
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_libName = (char *) (*env)->GetStringUTFChars(env, libName, NULL);
   rc_CreateL = optCreateL((optHandle_t *)&popt, local_libName, buffer_msg, sizeof(buffer_msg));
   (*env)->ReleaseStringUTFChars(env, libName, local_libName);
   local_msg = (*env)->NewStringUTF(env, buffer_msg);
   (*env)->SetObjectArrayElement(env, msg, 0, local_msg);
   (*env)->SetIntField(env, obj, fid, popt);
   return rc_CreateL;
}

JNIEXPORT jint JNICALL Java_optjava_Free(JNIEnv *env, jobject obj)
{
   int rc_Free;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_Free = optFree((optHandle_t *)&popt);
   (*env)->SetIntField(env, obj, fid, popt);
   return rc_Free;
}


JNIEXPORT jint JNICALL Java_optjava_ReadDefinition(JNIEnv *env, jobject obj, jstring fn)
{
   int rc_optReadDefinition;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_fn;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_fn = (char *)(*env)->GetStringUTFChars(env, fn, NULL);
   rc_optReadDefinition = optReadDefinition((optHandle_t)popt, local_fn);
   (*env)->ReleaseStringUTFChars(env, fn, local_fn);
   return rc_optReadDefinition;
}

JNIEXPORT jint JNICALL Java_optjava_ReadParameterFile(JNIEnv *env, jobject obj, jstring fn)
{
   int rc_optReadParameterFile;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_fn;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_fn = (char *)(*env)->GetStringUTFChars(env, fn, NULL);
   rc_optReadParameterFile = optReadParameterFile((optHandle_t)popt, local_fn);
   (*env)->ReleaseStringUTFChars(env, fn, local_fn);
   return rc_optReadParameterFile;
}

JNIEXPORT void JNICALL Java_optjava_ReadFromStr(JNIEnv *env, jobject obj, jstring s)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_s;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   local_s = (char *)(*env)->GetStringUTFChars(env, s, NULL);
   optReadFromStr((optHandle_t)popt, local_s);
   (*env)->ReleaseStringUTFChars(env, s, local_s);
}

JNIEXPORT jint JNICALL Java_optjava_WriteParameterFile(JNIEnv *env, jobject obj, jstring fn)
{
   int rc_optWriteParameterFile;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_fn;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_fn = (char *)(*env)->GetStringUTFChars(env, fn, NULL);
   rc_optWriteParameterFile = optWriteParameterFile((optHandle_t)popt, local_fn);
   (*env)->ReleaseStringUTFChars(env, fn, local_fn);
   return rc_optWriteParameterFile;
}

JNIEXPORT void JNICALL Java_optjava_ClearMessages(JNIEnv *env, jobject obj)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   optClearMessages((optHandle_t)popt);
}

JNIEXPORT void JNICALL Java_optjava_AddMessage(JNIEnv *env, jobject obj, jstring info)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_info;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   local_info = (char *)(*env)->GetStringUTFChars(env, info, NULL);
   optAddMessage((optHandle_t)popt, local_info);
   (*env)->ReleaseStringUTFChars(env, info, local_info);
}

JNIEXPORT void JNICALL Java_optjava_GetMessage(JNIEnv *env, jobject obj, jint N, jobjectArray info, jintArray iType)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_info;
   char buffer_info[256];
   int *local_iType;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_info[0] = '\0';
   local_iType = (*env)->GetIntArrayElements(env, iType, NULL);
   optGetMessage((optHandle_t)popt, N, buffer_info, local_iType);
   local_info = (*env)->NewStringUTF(env, buffer_info);
   (*env)->SetObjectArrayElement(env, info, 0, local_info);
   (*env)->ReleaseIntArrayElements(env, iType, local_iType, 0);
}

JNIEXPORT void JNICALL Java_optjava_ResetAll(JNIEnv *env, jobject obj)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   optResetAll((optHandle_t)popt);
}

JNIEXPORT void JNICALL Java_optjava_ResetAllRecent(JNIEnv *env, jobject obj)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   optResetAllRecent((optHandle_t)popt);
}

JNIEXPORT void JNICALL Java_optjava_ResetRecentChanges(JNIEnv *env, jobject obj)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   optResetRecentChanges((optHandle_t)popt);
}

JNIEXPORT void JNICALL Java_optjava_ShowHelp(JNIEnv *env, jobject obj, jstring HlpID)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_HlpID;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   local_HlpID = (char *)(*env)->GetStringUTFChars(env, HlpID, NULL);
   optShowHelp((optHandle_t)popt, local_HlpID);
   (*env)->ReleaseStringUTFChars(env, HlpID, local_HlpID);
}

JNIEXPORT jint JNICALL Java_optjava_ResetNr(JNIEnv *env, jobject obj, jint ANr)
{
   int rc_optResetNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_optResetNr = optResetNr((optHandle_t)popt, ANr);
   return rc_optResetNr;
}

JNIEXPORT jint JNICALL Java_optjava_FindStr(JNIEnv *env, jobject obj, jstring AName, jintArray ANr, jintArray ARefNr)
{
   int rc_optFindStr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_AName;
   int *local_ANr;
   int *local_ARefNr;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_AName = (char *)(*env)->GetStringUTFChars(env, AName, NULL);
   local_ANr = (*env)->GetIntArrayElements(env, ANr, NULL);
   local_ARefNr = (*env)->GetIntArrayElements(env, ARefNr, NULL);
   rc_optFindStr = optFindStr((optHandle_t)popt, local_AName, local_ANr, local_ARefNr);
   (*env)->ReleaseStringUTFChars(env, AName, local_AName);
   (*env)->ReleaseIntArrayElements(env, ANr, local_ANr, 0);
   (*env)->ReleaseIntArrayElements(env, ARefNr, local_ARefNr, 0);
   return rc_optFindStr;
}

JNIEXPORT jint JNICALL Java_optjava_GetInfoNr(JNIEnv *env, jobject obj, jint ANr, jintArray ADefined, jintArray ADefinedR, jintArray ARefNr, jintArray ADataType, jintArray AOptType, jintArray ASubType)
{
   int rc_optGetInfoNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_ADefined;
   int *local_ADefinedR;
   int *local_ARefNr;
   int *local_ADataType;
   int *local_AOptType;
   int *local_ASubType;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ADefined = (*env)->GetIntArrayElements(env, ADefined, NULL);
   local_ADefinedR = (*env)->GetIntArrayElements(env, ADefinedR, NULL);
   local_ARefNr = (*env)->GetIntArrayElements(env, ARefNr, NULL);
   local_ADataType = (*env)->GetIntArrayElements(env, ADataType, NULL);
   local_AOptType = (*env)->GetIntArrayElements(env, AOptType, NULL);
   local_ASubType = (*env)->GetIntArrayElements(env, ASubType, NULL);
   rc_optGetInfoNr = optGetInfoNr((optHandle_t)popt, ANr, local_ADefined, local_ADefinedR, local_ARefNr, local_ADataType, local_AOptType, local_ASubType);
   (*env)->ReleaseIntArrayElements(env, ADefined, local_ADefined, 0);
   (*env)->ReleaseIntArrayElements(env, ADefinedR, local_ADefinedR, 0);
   (*env)->ReleaseIntArrayElements(env, ARefNr, local_ARefNr, 0);
   (*env)->ReleaseIntArrayElements(env, ADataType, local_ADataType, 0);
   (*env)->ReleaseIntArrayElements(env, AOptType, local_AOptType, 0);
   (*env)->ReleaseIntArrayElements(env, ASubType, local_ASubType, 0);
   return rc_optGetInfoNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetValuesNr(JNIEnv *env, jobject obj, jint ANr, jobjectArray ASName, jintArray AIVal, jdoubleArray ADVal, jobjectArray ASVal)
{
   int rc_optGetValuesNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_ASName;
   char buffer_ASName[256];
   int *local_AIVal;
   double *local_ADVal;
   jstring local_ASVal;
   char buffer_ASVal[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_ASName[0] = '\0';
   local_AIVal = (*env)->GetIntArrayElements(env, AIVal, NULL);
   local_ADVal = (*env)->GetDoubleArrayElements(env, ADVal, NULL);
   buffer_ASVal[0] = '\0';
   rc_optGetValuesNr = optGetValuesNr((optHandle_t)popt, ANr, buffer_ASName, local_AIVal, local_ADVal, buffer_ASVal);
   local_ASName = (*env)->NewStringUTF(env, buffer_ASName);
   (*env)->SetObjectArrayElement(env, ASName, 0, local_ASName);
   (*env)->ReleaseIntArrayElements(env, AIVal, local_AIVal, 0);
   (*env)->ReleaseDoubleArrayElements(env, ADVal, local_ADVal, 0);
   local_ASVal = (*env)->NewStringUTF(env, buffer_ASVal);
   (*env)->SetObjectArrayElement(env, ASVal, 0, local_ASVal);
   return rc_optGetValuesNr;
}

JNIEXPORT jint JNICALL Java_optjava_SetValuesNr(JNIEnv *env, jobject obj, jint ANr, jint AIVal, jdouble ADVal, jstring ASVal)
{
   int rc_optSetValuesNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_ASVal;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ASVal = (char *)(*env)->GetStringUTFChars(env, ASVal, NULL);
   rc_optSetValuesNr = optSetValuesNr((optHandle_t)popt, ANr, AIVal, ADVal, local_ASVal);
   (*env)->ReleaseStringUTFChars(env, ASVal, local_ASVal);
   return rc_optSetValuesNr;
}

JNIEXPORT jint JNICALL Java_optjava_SetValues2Nr(JNIEnv *env, jobject obj, jint ANr, jint AIVal, jdouble ADVal, jstring ASVal)
{
   int rc_optSetValues2Nr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_ASVal;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ASVal = (char *)(*env)->GetStringUTFChars(env, ASVal, NULL);
   rc_optSetValues2Nr = optSetValues2Nr((optHandle_t)popt, ANr, AIVal, ADVal, local_ASVal);
   (*env)->ReleaseStringUTFChars(env, ASVal, local_ASVal);
   return rc_optSetValues2Nr;
}

JNIEXPORT void JNICALL Java_optjava_Version(JNIEnv *env, jobject obj, jobjectArray sversion)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_sversion;
   char buffer_sversion[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_sversion[0] = '\0';
   optVersion((optHandle_t)popt, buffer_sversion);
   local_sversion = (*env)->NewStringUTF(env, buffer_sversion);
   (*env)->SetObjectArrayElement(env, sversion, 0, local_sversion);
}

JNIEXPORT void JNICALL Java_optjava_DefinitionFile(JNIEnv *env, jobject obj, jobjectArray sfilename)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_sfilename;
   char buffer_sfilename[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_sfilename[0] = '\0';
   optDefinitionFile((optHandle_t)popt, buffer_sfilename);
   local_sfilename = (*env)->NewStringUTF(env, buffer_sfilename);
   (*env)->SetObjectArrayElement(env, sfilename, 0, local_sfilename);
}

JNIEXPORT jint JNICALL Java_optjava_GetFromAnyStrList(JNIEnv *env, jobject obj, jint idash, jobjectArray skey, jobjectArray sval)
{
   int rc_optGetFromAnyStrList;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_skey;
   char buffer_skey[256];
   jstring local_sval;
   char buffer_sval[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_skey[0] = '\0';
   buffer_sval[0] = '\0';
   rc_optGetFromAnyStrList = optGetFromAnyStrList((optHandle_t)popt, idash, buffer_skey, buffer_sval);
   local_skey = (*env)->NewStringUTF(env, buffer_skey);
   (*env)->SetObjectArrayElement(env, skey, 0, local_skey);
   local_sval = (*env)->NewStringUTF(env, buffer_sval);
   (*env)->SetObjectArrayElement(env, sval, 0, local_sval);
   return rc_optGetFromAnyStrList;
}

JNIEXPORT jint JNICALL Java_optjava_GetFromListStr(JNIEnv *env, jobject obj, jstring skey, jobjectArray sval)
{
   int rc_optGetFromListStr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_skey;
   jstring local_sval;
   char buffer_sval[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_skey = (char *)(*env)->GetStringUTFChars(env, skey, NULL);
   buffer_sval[0] = '\0';
   rc_optGetFromListStr = optGetFromListStr((optHandle_t)popt, local_skey, buffer_sval);
   (*env)->ReleaseStringUTFChars(env, skey, local_skey);
   local_sval = (*env)->NewStringUTF(env, buffer_sval);
   (*env)->SetObjectArrayElement(env, sval, 0, local_sval);
   return rc_optGetFromListStr;
}

JNIEXPORT jint JNICALL Java_optjava_ListCountStr(JNIEnv *env, jobject obj, jstring skey)
{
   int rc_optListCountStr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_skey;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_skey = (char *)(*env)->GetStringUTFChars(env, skey, NULL);
   rc_optListCountStr = optListCountStr((optHandle_t)popt, local_skey);
   (*env)->ReleaseStringUTFChars(env, skey, local_skey);
   return rc_optListCountStr;
}

JNIEXPORT jint JNICALL Java_optjava_ReadFromListStr(JNIEnv *env, jobject obj, jstring skey, jint iPos, jobjectArray sval)
{
   int rc_optReadFromListStr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_skey;
   jstring local_sval;
   char buffer_sval[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_skey = (char *)(*env)->GetStringUTFChars(env, skey, NULL);
   buffer_sval[0] = '\0';
   rc_optReadFromListStr = optReadFromListStr((optHandle_t)popt, local_skey, iPos, buffer_sval);
   (*env)->ReleaseStringUTFChars(env, skey, local_skey);
   local_sval = (*env)->NewStringUTF(env, buffer_sval);
   (*env)->SetObjectArrayElement(env, sval, 0, local_sval);
   return rc_optReadFromListStr;
}

JNIEXPORT jint JNICALL Java_optjava_SynonymCount(JNIEnv *env, jobject obj)
{
   int rc_optSynonymCount;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_optSynonymCount = optSynonymCount((optHandle_t)popt);
   return rc_optSynonymCount;
}

JNIEXPORT jint JNICALL Java_optjava_GetSynonym(JNIEnv *env, jobject obj, jint N, jobjectArray SSyn, jobjectArray SName)
{
   int rc_optGetSynonym;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_SSyn;
   char buffer_SSyn[256];
   jstring local_SName;
   char buffer_SName[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_SSyn[0] = '\0';
   buffer_SName[0] = '\0';
   rc_optGetSynonym = optGetSynonym((optHandle_t)popt, N, buffer_SSyn, buffer_SName);
   local_SSyn = (*env)->NewStringUTF(env, buffer_SSyn);
   (*env)->SetObjectArrayElement(env, SSyn, 0, local_SSyn);
   local_SName = (*env)->NewStringUTF(env, buffer_SName);
   (*env)->SetObjectArrayElement(env, SName, 0, local_SName);
   return rc_optGetSynonym;
}

JNIEXPORT void JNICALL Java_optjava_EchoSet(JNIEnv *env, jobject obj, jint V)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   optEchoSet((optHandle_t)popt, V);
}

JNIEXPORT jint JNICALL Java_optjava_EOLOnlySet(JNIEnv *env, jobject obj, jint ival)
{
   int rc_optEOLOnlySet;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_optEOLOnlySet = optEOLOnlySet((optHandle_t)popt, ival);
   return rc_optEOLOnlySet;
}

JNIEXPORT void JNICALL Java_optjava_NoBoundsSet(JNIEnv *env, jobject obj, jint ival)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   optNoBoundsSet((optHandle_t)popt, ival);
}

JNIEXPORT void JNICALL Java_optjava_ErrorCount(JNIEnv *env, jobject obj, jintArray iErrors, jintArray iWarnings)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_iErrors;
   int *local_iWarnings;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   local_iErrors = (*env)->GetIntArrayElements(env, iErrors, NULL);
   local_iWarnings = (*env)->GetIntArrayElements(env, iWarnings, NULL);
   optErrorCount((optHandle_t)popt, local_iErrors, local_iWarnings);
   (*env)->ReleaseIntArrayElements(env, iErrors, local_iErrors, 0);
   (*env)->ReleaseIntArrayElements(env, iWarnings, local_iWarnings, 0);
}

JNIEXPORT jint JNICALL Java_optjava_GetBoundsInt(JNIEnv *env, jobject obj, jint ANr, jintArray ilval, jintArray ihval, jintArray idval)
{
   int rc_optGetBoundsInt;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_ilval;
   int *local_ihval;
   int *local_idval;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ilval = (*env)->GetIntArrayElements(env, ilval, NULL);
   local_ihval = (*env)->GetIntArrayElements(env, ihval, NULL);
   local_idval = (*env)->GetIntArrayElements(env, idval, NULL);
   rc_optGetBoundsInt = optGetBoundsInt((optHandle_t)popt, ANr, local_ilval, local_ihval, local_idval);
   (*env)->ReleaseIntArrayElements(env, ilval, local_ilval, 0);
   (*env)->ReleaseIntArrayElements(env, ihval, local_ihval, 0);
   (*env)->ReleaseIntArrayElements(env, idval, local_idval, 0);
   return rc_optGetBoundsInt;
}

JNIEXPORT jint JNICALL Java_optjava_GetBoundsDbl(JNIEnv *env, jobject obj, jint ANr, jdoubleArray dlval, jdoubleArray dhval, jdoubleArray ddval)
{
   int rc_optGetBoundsDbl;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   double *local_dlval;
   double *local_dhval;
   double *local_ddval;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_dlval = (*env)->GetDoubleArrayElements(env, dlval, NULL);
   local_dhval = (*env)->GetDoubleArrayElements(env, dhval, NULL);
   local_ddval = (*env)->GetDoubleArrayElements(env, ddval, NULL);
   rc_optGetBoundsDbl = optGetBoundsDbl((optHandle_t)popt, ANr, local_dlval, local_dhval, local_ddval);
   (*env)->ReleaseDoubleArrayElements(env, dlval, local_dlval, 0);
   (*env)->ReleaseDoubleArrayElements(env, dhval, local_dhval, 0);
   (*env)->ReleaseDoubleArrayElements(env, ddval, local_ddval, 0);
   return rc_optGetBoundsDbl;
}

JNIEXPORT jint JNICALL Java_optjava_GetDefaultStr(JNIEnv *env, jobject obj, jint ANr, jobjectArray sval)
{
   int rc_optGetDefaultStr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_sval;
   char buffer_sval[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_sval[0] = '\0';
   rc_optGetDefaultStr = optGetDefaultStr((optHandle_t)popt, ANr, buffer_sval);
   local_sval = (*env)->NewStringUTF(env, buffer_sval);
   (*env)->SetObjectArrayElement(env, sval, 0, local_sval);
   return rc_optGetDefaultStr;
}

JNIEXPORT jint JNICALL Java_optjava_GetIntNr(JNIEnv *env, jobject obj, jint ANr, jintArray AIVal)
{
   int rc_optGetIntNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_AIVal;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_AIVal = (*env)->GetIntArrayElements(env, AIVal, NULL);
   rc_optGetIntNr = optGetIntNr((optHandle_t)popt, ANr, local_AIVal);
   (*env)->ReleaseIntArrayElements(env, AIVal, local_AIVal, 0);
   return rc_optGetIntNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetInt2Nr(JNIEnv *env, jobject obj, jint ANr, jintArray AIVal)
{
   int rc_optGetInt2Nr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_AIVal;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_AIVal = (*env)->GetIntArrayElements(env, AIVal, NULL);
   rc_optGetInt2Nr = optGetInt2Nr((optHandle_t)popt, ANr, local_AIVal);
   (*env)->ReleaseIntArrayElements(env, AIVal, local_AIVal, 0);
   return rc_optGetInt2Nr;
}

JNIEXPORT jint JNICALL Java_optjava_SetIntNr(JNIEnv *env, jobject obj, jint ANr, jint AIVal)
{
   int rc_optSetIntNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_optSetIntNr = optSetIntNr((optHandle_t)popt, ANr, AIVal);
   return rc_optSetIntNr;
}

JNIEXPORT jint JNICALL Java_optjava_SetInt2Nr(JNIEnv *env, jobject obj, jint ANr, jint AIVal)
{
   int rc_optSetInt2Nr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_optSetInt2Nr = optSetInt2Nr((optHandle_t)popt, ANr, AIVal);
   return rc_optSetInt2Nr;
}

JNIEXPORT jint JNICALL Java_optjava_GetStrNr(JNIEnv *env, jobject obj, jint ANr, jobjectArray ASVal)
{
   int rc_optGetStrNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_ASVal;
   char buffer_ASVal[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_ASVal[0] = '\0';
   rc_optGetStrNr = optGetStrNr((optHandle_t)popt, ANr, buffer_ASVal);
   local_ASVal = (*env)->NewStringUTF(env, buffer_ASVal);
   (*env)->SetObjectArrayElement(env, ASVal, 0, local_ASVal);
   return rc_optGetStrNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetOptHelpNr(JNIEnv *env, jobject obj, jint ANr, jobjectArray AName, jintArray AHc, jintArray AGroup)
{
   int rc_optGetOptHelpNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_AName;
   char buffer_AName[256];
   int *local_AHc;
   int *local_AGroup;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_AName[0] = '\0';
   local_AHc = (*env)->GetIntArrayElements(env, AHc, NULL);
   local_AGroup = (*env)->GetIntArrayElements(env, AGroup, NULL);
   rc_optGetOptHelpNr = optGetOptHelpNr((optHandle_t)popt, ANr, buffer_AName, local_AHc, local_AGroup);
   local_AName = (*env)->NewStringUTF(env, buffer_AName);
   (*env)->SetObjectArrayElement(env, AName, 0, local_AName);
   (*env)->ReleaseIntArrayElements(env, AHc, local_AHc, 0);
   (*env)->ReleaseIntArrayElements(env, AGroup, local_AGroup, 0);
   return rc_optGetOptHelpNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetEnumHelp(JNIEnv *env, jobject obj, jint ANr, jint AOrd, jintArray AHc, jobjectArray AHelpStr)
{
   int rc_optGetEnumHelp;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_AHc;
   jstring local_AHelpStr;
   char buffer_AHelpStr[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_AHc = (*env)->GetIntArrayElements(env, AHc, NULL);
   buffer_AHelpStr[0] = '\0';
   rc_optGetEnumHelp = optGetEnumHelp((optHandle_t)popt, ANr, AOrd, local_AHc, buffer_AHelpStr);
   (*env)->ReleaseIntArrayElements(env, AHc, local_AHc, 0);
   local_AHelpStr = (*env)->NewStringUTF(env, buffer_AHelpStr);
   (*env)->SetObjectArrayElement(env, AHelpStr, 0, local_AHelpStr);
   return rc_optGetEnumHelp;
}

JNIEXPORT jint JNICALL Java_optjava_GetEnumStrNr(JNIEnv *env, jobject obj, jint ANr, jobjectArray ASVal, jintArray AOrd)
{
   int rc_optGetEnumStrNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_ASVal;
   char buffer_ASVal[256];
   int *local_AOrd;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_ASVal[0] = '\0';
   local_AOrd = (*env)->GetIntArrayElements(env, AOrd, NULL);
   rc_optGetEnumStrNr = optGetEnumStrNr((optHandle_t)popt, ANr, buffer_ASVal, local_AOrd);
   local_ASVal = (*env)->NewStringUTF(env, buffer_ASVal);
   (*env)->SetObjectArrayElement(env, ASVal, 0, local_ASVal);
   (*env)->ReleaseIntArrayElements(env, AOrd, local_AOrd, 0);
   return rc_optGetEnumStrNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetEnumCount(JNIEnv *env, jobject obj, jint ANr, jintArray ACount)
{
   int rc_optGetEnumCount;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_ACount;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ACount = (*env)->GetIntArrayElements(env, ACount, NULL);
   rc_optGetEnumCount = optGetEnumCount((optHandle_t)popt, ANr, local_ACount);
   (*env)->ReleaseIntArrayElements(env, ACount, local_ACount, 0);
   return rc_optGetEnumCount;
}

JNIEXPORT jint JNICALL Java_optjava_GetEnumValue(JNIEnv *env, jobject obj, jint ANr, jint AOrd, jintArray AValInt, jobjectArray AValStr)
{
   int rc_optGetEnumValue;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_AValInt;
   jstring local_AValStr;
   char buffer_AValStr[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_AValInt = (*env)->GetIntArrayElements(env, AValInt, NULL);
   buffer_AValStr[0] = '\0';
   rc_optGetEnumValue = optGetEnumValue((optHandle_t)popt, ANr, AOrd, local_AValInt, buffer_AValStr);
   (*env)->ReleaseIntArrayElements(env, AValInt, local_AValInt, 0);
   local_AValStr = (*env)->NewStringUTF(env, buffer_AValStr);
   (*env)->SetObjectArrayElement(env, AValStr, 0, local_AValStr);
   return rc_optGetEnumValue;
}

JNIEXPORT jint JNICALL Java_optjava_GetStr2Nr(JNIEnv *env, jobject obj, jint ANr, jobjectArray ASVal)
{
   int rc_optGetStr2Nr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_ASVal;
   char buffer_ASVal[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_ASVal[0] = '\0';
   rc_optGetStr2Nr = optGetStr2Nr((optHandle_t)popt, ANr, buffer_ASVal);
   local_ASVal = (*env)->NewStringUTF(env, buffer_ASVal);
   (*env)->SetObjectArrayElement(env, ASVal, 0, local_ASVal);
   return rc_optGetStr2Nr;
}

JNIEXPORT jint JNICALL Java_optjava_SetStrNr(JNIEnv *env, jobject obj, jint ANr, jstring ASVal)
{
   int rc_optSetStrNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_ASVal;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ASVal = (char *)(*env)->GetStringUTFChars(env, ASVal, NULL);
   rc_optSetStrNr = optSetStrNr((optHandle_t)popt, ANr, local_ASVal);
   (*env)->ReleaseStringUTFChars(env, ASVal, local_ASVal);
   return rc_optSetStrNr;
}

JNIEXPORT jint JNICALL Java_optjava_SetStr2Nr(JNIEnv *env, jobject obj, jint ANr, jstring ASVal)
{
   int rc_optSetStr2Nr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_ASVal;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ASVal = (char *)(*env)->GetStringUTFChars(env, ASVal, NULL);
   rc_optSetStr2Nr = optSetStr2Nr((optHandle_t)popt, ANr, local_ASVal);
   (*env)->ReleaseStringUTFChars(env, ASVal, local_ASVal);
   return rc_optSetStr2Nr;
}

JNIEXPORT jint JNICALL Java_optjava_GetDblNr(JNIEnv *env, jobject obj, jint ANr, jdoubleArray ADVal)
{
   int rc_optGetDblNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   double *local_ADVal;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ADVal = (*env)->GetDoubleArrayElements(env, ADVal, NULL);
   rc_optGetDblNr = optGetDblNr((optHandle_t)popt, ANr, local_ADVal);
   (*env)->ReleaseDoubleArrayElements(env, ADVal, local_ADVal, 0);
   return rc_optGetDblNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetDbl2Nr(JNIEnv *env, jobject obj, jint ANr, jdoubleArray ADVal)
{
   int rc_optGetDbl2Nr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   double *local_ADVal;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ADVal = (*env)->GetDoubleArrayElements(env, ADVal, NULL);
   rc_optGetDbl2Nr = optGetDbl2Nr((optHandle_t)popt, ANr, local_ADVal);
   (*env)->ReleaseDoubleArrayElements(env, ADVal, local_ADVal, 0);
   return rc_optGetDbl2Nr;
}

JNIEXPORT jint JNICALL Java_optjava_SetDblNr(JNIEnv *env, jobject obj, jint ANr, jdouble ADVal)
{
   int rc_optSetDblNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_optSetDblNr = optSetDblNr((optHandle_t)popt, ANr, ADVal);
   return rc_optSetDblNr;
}

JNIEXPORT jint JNICALL Java_optjava_SetDbl2Nr(JNIEnv *env, jobject obj, jint ANr, jdouble ADVal)
{
   int rc_optSetDbl2Nr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_optSetDbl2Nr = optSetDbl2Nr((optHandle_t)popt, ANr, ADVal);
   return rc_optSetDbl2Nr;
}

JNIEXPORT jint JNICALL Java_optjava_GetValStr(JNIEnv *env, jobject obj, jstring AName, jobjectArray ASVal)
{
   int rc_optGetValStr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_AName;
   jstring local_ASVal;
   char buffer_ASVal[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_AName = (char *)(*env)->GetStringUTFChars(env, AName, NULL);
   buffer_ASVal[0] = '\0';
   rc_optGetValStr = optGetValStr((optHandle_t)popt, local_AName, buffer_ASVal);
   (*env)->ReleaseStringUTFChars(env, AName, local_AName);
   local_ASVal = (*env)->NewStringUTF(env, buffer_ASVal);
   (*env)->SetObjectArrayElement(env, ASVal, 0, local_ASVal);
   return rc_optGetValStr;
}

JNIEXPORT jint JNICALL Java_optjava_GetVal2Str(JNIEnv *env, jobject obj, jstring AName, jobjectArray ASVal)
{
   int rc_optGetVal2Str;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_AName;
   jstring local_ASVal;
   char buffer_ASVal[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_AName = (char *)(*env)->GetStringUTFChars(env, AName, NULL);
   buffer_ASVal[0] = '\0';
   rc_optGetVal2Str = optGetVal2Str((optHandle_t)popt, local_AName, buffer_ASVal);
   (*env)->ReleaseStringUTFChars(env, AName, local_AName);
   local_ASVal = (*env)->NewStringUTF(env, buffer_ASVal);
   (*env)->SetObjectArrayElement(env, ASVal, 0, local_ASVal);
   return rc_optGetVal2Str;
}

JNIEXPORT jint JNICALL Java_optjava_GetNameNr(JNIEnv *env, jobject obj, jint ANr, jobjectArray ASName)
{
   int rc_optGetNameNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_ASName;
   char buffer_ASName[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_ASName[0] = '\0';
   rc_optGetNameNr = optGetNameNr((optHandle_t)popt, ANr, buffer_ASName);
   local_ASName = (*env)->NewStringUTF(env, buffer_ASName);
   (*env)->SetObjectArrayElement(env, ASName, 0, local_ASName);
   return rc_optGetNameNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetDefinedNr(JNIEnv *env, jobject obj, jint ANr, jintArray AIVal)
{
   int rc_optGetDefinedNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_AIVal;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_AIVal = (*env)->GetIntArrayElements(env, AIVal, NULL);
   rc_optGetDefinedNr = optGetDefinedNr((optHandle_t)popt, ANr, local_AIVal);
   (*env)->ReleaseIntArrayElements(env, AIVal, local_AIVal, 0);
   return rc_optGetDefinedNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetHelpNr(JNIEnv *env, jobject obj, jint ANr, jobjectArray ASOpt, jobjectArray ASHelp)
{
   int rc_optGetHelpNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_ASOpt;
   char buffer_ASOpt[256];
   jstring local_ASHelp;
   char buffer_ASHelp[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_ASOpt[0] = '\0';
   buffer_ASHelp[0] = '\0';
   rc_optGetHelpNr = optGetHelpNr((optHandle_t)popt, ANr, buffer_ASOpt, buffer_ASHelp);
   local_ASOpt = (*env)->NewStringUTF(env, buffer_ASOpt);
   (*env)->SetObjectArrayElement(env, ASOpt, 0, local_ASOpt);
   local_ASHelp = (*env)->NewStringUTF(env, buffer_ASHelp);
   (*env)->SetObjectArrayElement(env, ASHelp, 0, local_ASHelp);
   return rc_optGetHelpNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetGroupNr(JNIEnv *env, jobject obj, jint ANr, jobjectArray AName, jintArray AGroup, jintArray AHc, jobjectArray AHelp)
{
   int rc_optGetGroupNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_AName;
   char buffer_AName[256];
   int *local_AGroup;
   int *local_AHc;
   jstring local_AHelp;
   char buffer_AHelp[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_AName[0] = '\0';
   local_AGroup = (*env)->GetIntArrayElements(env, AGroup, NULL);
   local_AHc = (*env)->GetIntArrayElements(env, AHc, NULL);
   buffer_AHelp[0] = '\0';
   rc_optGetGroupNr = optGetGroupNr((optHandle_t)popt, ANr, buffer_AName, local_AGroup, local_AHc, buffer_AHelp);
   local_AName = (*env)->NewStringUTF(env, buffer_AName);
   (*env)->SetObjectArrayElement(env, AName, 0, local_AName);
   (*env)->ReleaseIntArrayElements(env, AGroup, local_AGroup, 0);
   (*env)->ReleaseIntArrayElements(env, AHc, local_AHc, 0);
   local_AHelp = (*env)->NewStringUTF(env, buffer_AHelp);
   (*env)->SetObjectArrayElement(env, AHelp, 0, local_AHelp);
   return rc_optGetGroupNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetGroupGrpNr(JNIEnv *env, jobject obj, jint AGroup)
{
   int rc_optGetGroupGrpNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_optGetGroupGrpNr = optGetGroupGrpNr((optHandle_t)popt, AGroup);
   return rc_optGetGroupGrpNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetOptGroupNr(JNIEnv *env, jobject obj, jint ANr)
{
   int rc_optGetOptGroupNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_optGetOptGroupNr = optGetOptGroupNr((optHandle_t)popt, ANr);
   return rc_optGetOptGroupNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetDotOptNr(JNIEnv *env, jobject obj, jint ANr, jobjectArray AName, jintArray AObjNr, jintArray ADim, jdoubleArray AValue)
{
   int rc_optGetDotOptNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_AName;
   char buffer_AName[256];
   int *local_AObjNr;
   int *local_ADim;
   double *local_AValue;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_AName[0] = '\0';
   local_AObjNr = (*env)->GetIntArrayElements(env, AObjNr, NULL);
   local_ADim = (*env)->GetIntArrayElements(env, ADim, NULL);
   local_AValue = (*env)->GetDoubleArrayElements(env, AValue, NULL);
   rc_optGetDotOptNr = optGetDotOptNr((optHandle_t)popt, ANr, buffer_AName, local_AObjNr, local_ADim, local_AValue);
   local_AName = (*env)->NewStringUTF(env, buffer_AName);
   (*env)->SetObjectArrayElement(env, AName, 0, local_AName);
   (*env)->ReleaseIntArrayElements(env, AObjNr, local_AObjNr, 0);
   (*env)->ReleaseIntArrayElements(env, ADim, local_ADim, 0);
   (*env)->ReleaseDoubleArrayElements(env, AValue, local_AValue, 0);
   return rc_optGetDotOptNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetDotOptUel(JNIEnv *env, jobject obj, jint ANr, jint ADim, jobjectArray AUEL)
{
   int rc_optGetDotOptUel;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_AUEL;
   char buffer_AUEL[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_AUEL[0] = '\0';
   rc_optGetDotOptUel = optGetDotOptUel((optHandle_t)popt, ANr, ADim, buffer_AUEL);
   local_AUEL = (*env)->NewStringUTF(env, buffer_AUEL);
   (*env)->SetObjectArrayElement(env, AUEL, 0, local_AUEL);
   return rc_optGetDotOptUel;
}

JNIEXPORT jint JNICALL Java_optjava_GetIndicatorNr(JNIEnv *env, jobject obj, jint ANr, jobjectArray EquName, jobjectArray VarName, jintArray EquDim, jintArray VarDim, jintArray AValue)
{
   int rc_optGetIndicatorNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_EquName;
   char buffer_EquName[256];
   jstring local_VarName;
   char buffer_VarName[256];
   int *local_EquDim;
   int *local_VarDim;
   int *local_AValue;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_EquName[0] = '\0';
   buffer_VarName[0] = '\0';
   local_EquDim = (*env)->GetIntArrayElements(env, EquDim, NULL);
   local_VarDim = (*env)->GetIntArrayElements(env, VarDim, NULL);
   local_AValue = (*env)->GetIntArrayElements(env, AValue, NULL);
   rc_optGetIndicatorNr = optGetIndicatorNr((optHandle_t)popt, ANr, buffer_EquName, buffer_VarName, local_EquDim, local_VarDim, local_AValue);
   local_EquName = (*env)->NewStringUTF(env, buffer_EquName);
   (*env)->SetObjectArrayElement(env, EquName, 0, local_EquName);
   local_VarName = (*env)->NewStringUTF(env, buffer_VarName);
   (*env)->SetObjectArrayElement(env, VarName, 0, local_VarName);
   (*env)->ReleaseIntArrayElements(env, EquDim, local_EquDim, 0);
   (*env)->ReleaseIntArrayElements(env, VarDim, local_VarDim, 0);
   (*env)->ReleaseIntArrayElements(env, AValue, local_AValue, 0);
   return rc_optGetIndicatorNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetEquIndicatorNr(JNIEnv *env, jobject obj, jint ANr, jint ADim, jobjectArray AIndex)
{
   int rc_optGetEquIndicatorNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_AIndex;
   char buffer_AIndex[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_AIndex[0] = '\0';
   rc_optGetEquIndicatorNr = optGetEquIndicatorNr((optHandle_t)popt, ANr, ADim, buffer_AIndex);
   local_AIndex = (*env)->NewStringUTF(env, buffer_AIndex);
   (*env)->SetObjectArrayElement(env, AIndex, 0, local_AIndex);
   return rc_optGetEquIndicatorNr;
}

JNIEXPORT jint JNICALL Java_optjava_GetVarIndicatorNr(JNIEnv *env, jobject obj, jint ANr, jint ADim, jobjectArray AIndex)
{
   int rc_optGetVarIndicatorNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_AIndex;
   char buffer_AIndex[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_AIndex[0] = '\0';
   rc_optGetVarIndicatorNr = optGetVarIndicatorNr((optHandle_t)popt, ANr, ADim, buffer_AIndex);
   local_AIndex = (*env)->NewStringUTF(env, buffer_AIndex);
   (*env)->SetObjectArrayElement(env, AIndex, 0, local_AIndex);
   return rc_optGetVarIndicatorNr;
}

JNIEXPORT jint JNICALL Java_optjava_IndicatorCount(JNIEnv *env, jobject obj, jintArray ANrErrors)
{
   int rc_optIndicatorCount;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_ANrErrors;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ANrErrors = (*env)->GetIntArrayElements(env, ANrErrors, NULL);
   rc_optIndicatorCount = optIndicatorCount((optHandle_t)popt, local_ANrErrors);
   (*env)->ReleaseIntArrayElements(env, ANrErrors, local_ANrErrors, 0);
   return rc_optIndicatorCount;
}

JNIEXPORT jint JNICALL Java_optjava_DotOptCount(JNIEnv *env, jobject obj, jintArray ANrErrors)
{
   int rc_optDotOptCount;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   int *local_ANrErrors;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_ANrErrors = (*env)->GetIntArrayElements(env, ANrErrors, NULL);
   rc_optDotOptCount = optDotOptCount((optHandle_t)popt, local_ANrErrors);
   (*env)->ReleaseIntArrayElements(env, ANrErrors, local_ANrErrors, 0);
   return rc_optDotOptCount;
}

JNIEXPORT jint JNICALL Java_optjava_SetRefNr(JNIEnv *env, jobject obj, jint ANr, jint AValue)
{
   int rc_optSetRefNr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   rc_optSetRefNr = optSetRefNr((optHandle_t)popt, ANr, AValue);
   return rc_optSetRefNr;
}

JNIEXPORT jint JNICALL Java_optjava_SetRefNrStr(JNIEnv *env, jobject obj, jstring AOpt, jint AValue)
{
   int rc_optSetRefNrStr;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_AOpt;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_AOpt = (char *)(*env)->GetStringUTFChars(env, AOpt, NULL);
   rc_optSetRefNrStr = optSetRefNrStr((optHandle_t)popt, local_AOpt, AValue);
   (*env)->ReleaseStringUTFChars(env, AOpt, local_AOpt);
   return rc_optSetRefNrStr;
}

JNIEXPORT jint JNICALL Java_optjava_GetConstName(JNIEnv *env, jobject obj, jint cgroup, jint cindex, jobjectArray cname)
{
   int rc_optGetConstName;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_cname;
   char buffer_cname[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_cname[0] = '\0';
   rc_optGetConstName = optGetConstName((optHandle_t)popt, cgroup, cindex, buffer_cname);
   local_cname = (*env)->NewStringUTF(env, buffer_cname);
   (*env)->SetObjectArrayElement(env, cname, 0, local_cname);
   return rc_optGetConstName;
}

JNIEXPORT jint JNICALL Java_optjava_GetTypeName(JNIEnv *env, jobject obj, jint TNr, jobjectArray sTName)
{
   int rc_optGetTypeName;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_sTName;
   char buffer_sTName[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_sTName[0] = '\0';
   rc_optGetTypeName = optGetTypeName((optHandle_t)popt, TNr, buffer_sTName);
   local_sTName = (*env)->NewStringUTF(env, buffer_sTName);
   (*env)->SetObjectArrayElement(env, sTName, 0, local_sTName);
   return rc_optGetTypeName;
}

JNIEXPORT jint JNICALL Java_optjava_LookUp(JNIEnv *env, jobject obj, jstring AOpt)
{
   int rc_optLookUp;
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   char *local_AOpt;
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   local_AOpt = (char *)(*env)->GetStringUTFChars(env, AOpt, NULL);
   rc_optLookUp = optLookUp((optHandle_t)popt, local_AOpt);
   (*env)->ReleaseStringUTFChars(env, AOpt, local_AOpt);
   return rc_optLookUp;
}

JNIEXPORT void JNICALL Java_optjava_ReadFromPChar(JNIEnv *env, jobject obj, jobjectArray p)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   jstring local_p;
   char buffer_p[256];
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return ;
   popt = (*env)->GetIntField(env, obj, fid);
   buffer_p[0] = '\0';
   optReadFromPChar((optHandle_t)popt, buffer_p);
   local_p = (*env)->NewStringUTF(env, buffer_p);
   (*env)->SetObjectArrayElement(env, p, 0, local_p);
}

JNIEXPORT jint JNICALL Java_optjava_Count(JNIEnv *env, jobject obj){
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   return optCount((optHandle_t)popt);
}

JNIEXPORT jint JNICALL Java_optjava_MessageCount(JNIEnv *env, jobject obj){
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   return optMessageCount((optHandle_t)popt);
}

JNIEXPORT jint JNICALL Java_optjava_GroupCount(JNIEnv *env, jobject obj){
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   return optGroupCount((optHandle_t)popt);
}

JNIEXPORT jint JNICALL Java_optjava_RecentEnabled(JNIEnv *env, jobject obj){
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return 0;
   popt = (*env)->GetIntField(env, obj, fid);
   return optRecentEnabled((optHandle_t)popt);
}

JNIEXPORT void JNICALL Java_optjava_RecentEnabledSet(JNIEnv *env, jobject obj, jint x)
{
   jfieldID fid;
   int popt;
   jclass cls = (*env)->GetObjectClass(env, obj);
   fid = (*env)->GetFieldID(env, cls, "optPtr", "I");
   if (fid == NULL) return;
   popt = (*env)->GetIntField(env, obj, fid);
   optRecentEnabledSet((optHandle_t)popt, x);
}
